/* ***********************************************************
 * This file was automatically generated on 2020-02-28.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.function.Consumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingStatus;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

import com.tinkerforge.BrickletDustDetector;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletDustDetectorWrapper extends BrickletDustDetector implements StandardFlashable, DeviceWrapper {
    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletDustDetector.DEVICE_DISPLAY_NAME, "brickletdustdetector", BrickletDustDetector.DEVICE_IDENTIFIER, BrickletDustDetectorWrapper.class, BrickletDustDetectorActions.class, "2.0.0", false);

    public BrickletDustDetectorWrapper(String uid, IPConnection ipcon) {
        super(uid, ipcon);
    }

    private List<ScheduledFuture<?>> manualChannelUpdates = new ArrayList<ScheduledFuture<?>>();
    private List<ListenerReg> listenerRegs = new ArrayList<ListenerReg>();

    public void cancelManualUpdates() {
        manualChannelUpdates.forEach(f -> f.cancel(true));
    }

    public <T> T reg(T listener, Consumer<T> toRemove) {
        listenerRegs.add(new ListenerReg<T>(listener, toRemove));
        return listener;
    }

    
    private final Logger logger = LoggerFactory.getLogger(BrickletDustDetectorWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletDustDetectorWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        this.setResponseExpectedAll(true);
        BrickletDustDetectorConfig cfg = (BrickletDustDetectorConfig) config.as(BrickletDustDetectorConfig.class);
        this.addDustDensityListener(this.reg((dustDensity) -> {if(true) {updateStateFn.accept("BrickletDustDetectorDustDensity", transformBrickletDustDetectorDustDensityCallback0(dustDensity, cfg));}}, this::removeDustDensityListener));
        this.setMovingAverage(cfg.movingAverageLength.shortValue());
		{
		BrickletDustDetectorDustDensityConfig channelCfg = getChannelConfigFn.apply("BrickletDustDetectorDustDensity").as(BrickletDustDetectorDustDensityConfig.class);
		this.setDustDensityCallbackPeriod(channelCfg.updateInterval);
		this.setDustDensityCallbackThreshold('x', 0, 0);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        listenerRegs.forEach(reg -> reg.toRemove.accept(reg.listener));

        BrickletDustDetectorConfig cfg = (BrickletDustDetectorConfig) config.as(BrickletDustDetectorConfig.class);
        this.setDustDensityCallbackPeriod(0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletDustDetectorConfig cfg = (BrickletDustDetectorConfig) config.as(BrickletDustDetectorConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletDustDetectorDustDensity");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletDustDetectorDustDensity":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletDustDetectorDustDensity"), "Dust Density", "Number:Density").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletDustDetectorDustDensity")).withDescription("The dust density.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(500)).withPattern("%d %unit%").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Dust Detector Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures dust density").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletDustDetectorDustDensity", new ChannelTypeUID("tinkerforge", "BrickletDustDetectorDustDensity")).withLabel("Dust Density").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletdustdetector":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("movingAverageLength", Type.INTEGER).withDefault("100").withDescription("The length of a moving averaging for the dust_density.<br/><br/>Setting the length to 0 will turn the averaging completely off. With less averaging, there is more noise on the data.").withLabel("Moving Average Length").withAdvanced(true).withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(100)).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletDustDetectorDustDensity":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletDustDetectorConfig cfg = (BrickletDustDetectorConfig) config.as(BrickletDustDetectorConfig.class);
        switch(channel) {
            case "BrickletDustDetectorDustDensity": {
                   BrickletDustDetectorDustDensityConfig channelCfg = channelConfig.as(BrickletDustDetectorDustDensityConfig.class);
                   {
            int value = this.getDustDensity();
            if(true)
                updateStateFn.accept(channel, transformBrickletDustDetectorDustDensityGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletDustDetectorConfig cfg = (BrickletDustDetectorConfig) config.as(BrickletDustDetectorConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletDustDetectorDustDensityCallback0(int dustDensity, BrickletDustDetectorConfig cfg) {
        return new QuantityType<>(dustDensity, SmartHomeUnits.MICROGRAM_PER_CUBICMETRE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletDustDetectorDustDensityGetter0(int value, BrickletDustDetectorConfig cfg) {
        return new QuantityType<>(value, SmartHomeUnits.MICROGRAM_PER_CUBICMETRE);
    }

}