/* ***********************************************************
 * This file was automatically generated on 2020-02-28.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.function.Consumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingStatus;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;
import org.eclipse.smarthome.core.library.types.StringType;

import com.tinkerforge.BrickletIO16;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletIO16Wrapper extends BrickletIO16 implements StandardFlashable, DeviceWrapper {
    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletIO16.DEVICE_DISPLAY_NAME, "brickletio16", BrickletIO16.DEVICE_IDENTIFIER, BrickletIO16Wrapper.class, BrickletIO16Actions.class, "2.0.3", false);

    public BrickletIO16Wrapper(String uid, IPConnection ipcon) {
        super(uid, ipcon);
    }

    private List<ScheduledFuture<?>> manualChannelUpdates = new ArrayList<ScheduledFuture<?>>();
    private List<ListenerReg> listenerRegs = new ArrayList<ListenerReg>();

    public void cancelManualUpdates() {
        manualChannelUpdates.forEach(f -> f.cancel(true));
    }

    public <T> T reg(T listener, Consumer<T> toRemove) {
        listenerRegs.add(new ListenerReg<T>(listener, toRemove));
        return listener;
    }

    
    private final Logger logger = LoggerFactory.getLogger(BrickletIO16Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletIO16Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        this.setResponseExpectedAll(true);
        BrickletIO16Config cfg = (BrickletIO16Config) config.as(BrickletIO16Config.class);
        if(cfg.pinConfiguration0 > 1) {
this.addInterruptListener(this.reg((port, interruptMask, valueMask) -> {if(port == 'a' && (interruptMask & (1 << 0)) > 0) {updateStateFn.accept("BrickletIO16InputPin0", transformBrickletIO16InputPin0Callback0(port, interruptMask, valueMask, cfg));}}, this::removeInterruptListener));}
		if(cfg.pinConfiguration1 > 1) {
this.addInterruptListener(this.reg((port, interruptMask, valueMask) -> {if(port == 'a' && (interruptMask & (1 << 1)) > 0) {updateStateFn.accept("BrickletIO16InputPin1", transformBrickletIO16InputPin1Callback0(port, interruptMask, valueMask, cfg));}}, this::removeInterruptListener));}
		if(cfg.pinConfiguration2 > 1) {
this.addInterruptListener(this.reg((port, interruptMask, valueMask) -> {if(port == 'a' && (interruptMask & (1 << 2)) > 0) {updateStateFn.accept("BrickletIO16InputPin2", transformBrickletIO16InputPin2Callback0(port, interruptMask, valueMask, cfg));}}, this::removeInterruptListener));}
		if(cfg.pinConfiguration3 > 1) {
this.addInterruptListener(this.reg((port, interruptMask, valueMask) -> {if(port == 'a' && (interruptMask & (1 << 3)) > 0) {updateStateFn.accept("BrickletIO16InputPin3", transformBrickletIO16InputPin3Callback0(port, interruptMask, valueMask, cfg));}}, this::removeInterruptListener));}
		if(cfg.pinConfiguration4 > 1) {
this.addInterruptListener(this.reg((port, interruptMask, valueMask) -> {if(port == 'a' && (interruptMask & (1 << 4)) > 0) {updateStateFn.accept("BrickletIO16InputPin4", transformBrickletIO16InputPin4Callback0(port, interruptMask, valueMask, cfg));}}, this::removeInterruptListener));}
		if(cfg.pinConfiguration5 > 1) {
this.addInterruptListener(this.reg((port, interruptMask, valueMask) -> {if(port == 'a' && (interruptMask & (1 << 5)) > 0) {updateStateFn.accept("BrickletIO16InputPin5", transformBrickletIO16InputPin5Callback0(port, interruptMask, valueMask, cfg));}}, this::removeInterruptListener));}
		if(cfg.pinConfiguration6 > 1) {
this.addInterruptListener(this.reg((port, interruptMask, valueMask) -> {if(port == 'a' && (interruptMask & (1 << 6)) > 0) {updateStateFn.accept("BrickletIO16InputPin6", transformBrickletIO16InputPin6Callback0(port, interruptMask, valueMask, cfg));}}, this::removeInterruptListener));}
		if(cfg.pinConfiguration7 > 1) {
this.addInterruptListener(this.reg((port, interruptMask, valueMask) -> {if(port == 'a' && (interruptMask & (1 << 7)) > 0) {updateStateFn.accept("BrickletIO16InputPin7", transformBrickletIO16InputPin7Callback0(port, interruptMask, valueMask, cfg));}}, this::removeInterruptListener));}
		if(cfg.pinConfiguration8 > 1) {
this.addInterruptListener(this.reg((port, interruptMask, valueMask) -> {if(port == 'b' && (interruptMask & (1 << 0)) > 0) {updateStateFn.accept("BrickletIO16InputPin8", transformBrickletIO16InputPin8Callback0(port, interruptMask, valueMask, cfg));}}, this::removeInterruptListener));}
		if(cfg.pinConfiguration9 > 1) {
this.addInterruptListener(this.reg((port, interruptMask, valueMask) -> {if(port == 'b' && (interruptMask & (1 << 1)) > 0) {updateStateFn.accept("BrickletIO16InputPin9", transformBrickletIO16InputPin9Callback0(port, interruptMask, valueMask, cfg));}}, this::removeInterruptListener));}
		if(cfg.pinConfiguration10 > 1) {
this.addInterruptListener(this.reg((port, interruptMask, valueMask) -> {if(port == 'b' && (interruptMask & (1 << 2)) > 0) {updateStateFn.accept("BrickletIO16InputPin10", transformBrickletIO16InputPin10Callback0(port, interruptMask, valueMask, cfg));}}, this::removeInterruptListener));}
		if(cfg.pinConfiguration11 > 1) {
this.addInterruptListener(this.reg((port, interruptMask, valueMask) -> {if(port == 'b' && (interruptMask & (1 << 3)) > 0) {updateStateFn.accept("BrickletIO16InputPin11", transformBrickletIO16InputPin11Callback0(port, interruptMask, valueMask, cfg));}}, this::removeInterruptListener));}
		if(cfg.pinConfiguration12 > 1) {
this.addInterruptListener(this.reg((port, interruptMask, valueMask) -> {if(port == 'b' && (interruptMask & (1 << 4)) > 0) {updateStateFn.accept("BrickletIO16InputPin12", transformBrickletIO16InputPin12Callback0(port, interruptMask, valueMask, cfg));}}, this::removeInterruptListener));}
		if(cfg.pinConfiguration13 > 1) {
this.addInterruptListener(this.reg((port, interruptMask, valueMask) -> {if(port == 'b' && (interruptMask & (1 << 5)) > 0) {updateStateFn.accept("BrickletIO16InputPin13", transformBrickletIO16InputPin13Callback0(port, interruptMask, valueMask, cfg));}}, this::removeInterruptListener));}
		if(cfg.pinConfiguration14 > 1) {
this.addInterruptListener(this.reg((port, interruptMask, valueMask) -> {if(port == 'b' && (interruptMask & (1 << 6)) > 0) {updateStateFn.accept("BrickletIO16InputPin14", transformBrickletIO16InputPin14Callback0(port, interruptMask, valueMask, cfg));}}, this::removeInterruptListener));}
		if(cfg.pinConfiguration15 > 1) {
this.addInterruptListener(this.reg((port, interruptMask, valueMask) -> {if(port == 'b' && (interruptMask & (1 << 7)) > 0) {updateStateFn.accept("BrickletIO16InputPin15", transformBrickletIO16InputPin15Callback0(port, interruptMask, valueMask, cfg));}}, this::removeInterruptListener));}
		if(cfg.pinConfiguration0 <= 1) {
this.addMonoflopDoneListener(this.reg((port, selectionMask, valueMask) -> {if(port == 'a' && (selectionMask & (1 << 0)) > 0) {updateStateFn.accept("BrickletIO16OutputPin0", transformBrickletIO16OutputPin0Callback0(port, selectionMask, valueMask, cfg));}}, this::removeMonoflopDoneListener));}
		if(cfg.pinConfiguration1 <= 1) {
this.addMonoflopDoneListener(this.reg((port, selectionMask, valueMask) -> {if(port == 'a' && (selectionMask & (1 << 1)) > 0) {updateStateFn.accept("BrickletIO16OutputPin1", transformBrickletIO16OutputPin1Callback0(port, selectionMask, valueMask, cfg));}}, this::removeMonoflopDoneListener));}
		if(cfg.pinConfiguration2 <= 1) {
this.addMonoflopDoneListener(this.reg((port, selectionMask, valueMask) -> {if(port == 'a' && (selectionMask & (1 << 2)) > 0) {updateStateFn.accept("BrickletIO16OutputPin2", transformBrickletIO16OutputPin2Callback0(port, selectionMask, valueMask, cfg));}}, this::removeMonoflopDoneListener));}
		if(cfg.pinConfiguration3 <= 1) {
this.addMonoflopDoneListener(this.reg((port, selectionMask, valueMask) -> {if(port == 'a' && (selectionMask & (1 << 3)) > 0) {updateStateFn.accept("BrickletIO16OutputPin3", transformBrickletIO16OutputPin3Callback0(port, selectionMask, valueMask, cfg));}}, this::removeMonoflopDoneListener));}
		if(cfg.pinConfiguration4 <= 1) {
this.addMonoflopDoneListener(this.reg((port, selectionMask, valueMask) -> {if(port == 'a' && (selectionMask & (1 << 4)) > 0) {updateStateFn.accept("BrickletIO16OutputPin4", transformBrickletIO16OutputPin4Callback0(port, selectionMask, valueMask, cfg));}}, this::removeMonoflopDoneListener));}
		if(cfg.pinConfiguration5 <= 1) {
this.addMonoflopDoneListener(this.reg((port, selectionMask, valueMask) -> {if(port == 'a' && (selectionMask & (1 << 5)) > 0) {updateStateFn.accept("BrickletIO16OutputPin5", transformBrickletIO16OutputPin5Callback0(port, selectionMask, valueMask, cfg));}}, this::removeMonoflopDoneListener));}
		if(cfg.pinConfiguration6 <= 1) {
this.addMonoflopDoneListener(this.reg((port, selectionMask, valueMask) -> {if(port == 'a' && (selectionMask & (1 << 6)) > 0) {updateStateFn.accept("BrickletIO16OutputPin6", transformBrickletIO16OutputPin6Callback0(port, selectionMask, valueMask, cfg));}}, this::removeMonoflopDoneListener));}
		if(cfg.pinConfiguration7 <= 1) {
this.addMonoflopDoneListener(this.reg((port, selectionMask, valueMask) -> {if(port == 'a' && (selectionMask & (1 << 7)) > 0) {updateStateFn.accept("BrickletIO16OutputPin7", transformBrickletIO16OutputPin7Callback0(port, selectionMask, valueMask, cfg));}}, this::removeMonoflopDoneListener));}
		if(cfg.pinConfiguration8 <= 1) {
this.addMonoflopDoneListener(this.reg((port, selectionMask, valueMask) -> {if(port == 'b' && (selectionMask & (1 << 0)) > 0) {updateStateFn.accept("BrickletIO16OutputPin8", transformBrickletIO16OutputPin8Callback0(port, selectionMask, valueMask, cfg));}}, this::removeMonoflopDoneListener));}
		if(cfg.pinConfiguration9 <= 1) {
this.addMonoflopDoneListener(this.reg((port, selectionMask, valueMask) -> {if(port == 'b' && (selectionMask & (1 << 1)) > 0) {updateStateFn.accept("BrickletIO16OutputPin9", transformBrickletIO16OutputPin9Callback0(port, selectionMask, valueMask, cfg));}}, this::removeMonoflopDoneListener));}
		if(cfg.pinConfiguration10 <= 1) {
this.addMonoflopDoneListener(this.reg((port, selectionMask, valueMask) -> {if(port == 'b' && (selectionMask & (1 << 2)) > 0) {updateStateFn.accept("BrickletIO16OutputPin10", transformBrickletIO16OutputPin10Callback0(port, selectionMask, valueMask, cfg));}}, this::removeMonoflopDoneListener));}
		if(cfg.pinConfiguration11 <= 1) {
this.addMonoflopDoneListener(this.reg((port, selectionMask, valueMask) -> {if(port == 'b' && (selectionMask & (1 << 3)) > 0) {updateStateFn.accept("BrickletIO16OutputPin11", transformBrickletIO16OutputPin11Callback0(port, selectionMask, valueMask, cfg));}}, this::removeMonoflopDoneListener));}
		if(cfg.pinConfiguration12 <= 1) {
this.addMonoflopDoneListener(this.reg((port, selectionMask, valueMask) -> {if(port == 'b' && (selectionMask & (1 << 4)) > 0) {updateStateFn.accept("BrickletIO16OutputPin12", transformBrickletIO16OutputPin12Callback0(port, selectionMask, valueMask, cfg));}}, this::removeMonoflopDoneListener));}
		if(cfg.pinConfiguration13 <= 1) {
this.addMonoflopDoneListener(this.reg((port, selectionMask, valueMask) -> {if(port == 'b' && (selectionMask & (1 << 5)) > 0) {updateStateFn.accept("BrickletIO16OutputPin13", transformBrickletIO16OutputPin13Callback0(port, selectionMask, valueMask, cfg));}}, this::removeMonoflopDoneListener));}
		if(cfg.pinConfiguration14 <= 1) {
this.addMonoflopDoneListener(this.reg((port, selectionMask, valueMask) -> {if(port == 'b' && (selectionMask & (1 << 6)) > 0) {updateStateFn.accept("BrickletIO16OutputPin14", transformBrickletIO16OutputPin14Callback0(port, selectionMask, valueMask, cfg));}}, this::removeMonoflopDoneListener));}
		if(cfg.pinConfiguration15 <= 1) {
this.addMonoflopDoneListener(this.reg((port, selectionMask, valueMask) -> {if(port == 'b' && (selectionMask & (1 << 7)) > 0) {updateStateFn.accept("BrickletIO16OutputPin15", transformBrickletIO16OutputPin15Callback0(port, selectionMask, valueMask, cfg));}}, this::removeMonoflopDoneListener));}
        
		if (cfg.pinConfiguration0 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16InputPin0").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 0), 'i', cfg.pinConfiguration0 % 2 == 1);
		            this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') | (1 << 0)));
		}
		if (cfg.pinConfiguration1 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16InputPin1").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 1), 'i', cfg.pinConfiguration1 % 2 == 1);
		            this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') | (1 << 1)));
		}
		if (cfg.pinConfiguration2 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16InputPin2").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 2), 'i', cfg.pinConfiguration2 % 2 == 1);
		            this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') | (1 << 2)));
		}
		if (cfg.pinConfiguration3 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16InputPin3").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 3), 'i', cfg.pinConfiguration3 % 2 == 1);
		            this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') | (1 << 3)));
		}
		if (cfg.pinConfiguration4 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16InputPin4").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 4), 'i', cfg.pinConfiguration4 % 2 == 1);
		            this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') | (1 << 4)));
		}
		if (cfg.pinConfiguration5 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16InputPin5").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 5), 'i', cfg.pinConfiguration5 % 2 == 1);
		            this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') | (1 << 5)));
		}
		if (cfg.pinConfiguration6 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16InputPin6").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 6), 'i', cfg.pinConfiguration6 % 2 == 1);
		            this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') | (1 << 6)));
		}
		if (cfg.pinConfiguration7 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16InputPin7").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 7), 'i', cfg.pinConfiguration7 % 2 == 1);
		            this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') | (1 << 7)));
		}
		if (cfg.pinConfiguration8 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16InputPin8").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 0), 'i', cfg.pinConfiguration8 % 2 == 1);
		            this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') | (1 << 0)));
		}
		if (cfg.pinConfiguration9 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16InputPin9").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 1), 'i', cfg.pinConfiguration9 % 2 == 1);
		            this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') | (1 << 1)));
		}
		if (cfg.pinConfiguration10 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16InputPin10").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 2), 'i', cfg.pinConfiguration10 % 2 == 1);
		            this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') | (1 << 2)));
		}
		if (cfg.pinConfiguration11 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16InputPin11").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 3), 'i', cfg.pinConfiguration11 % 2 == 1);
		            this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') | (1 << 3)));
		}
		if (cfg.pinConfiguration12 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16InputPin12").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 4), 'i', cfg.pinConfiguration12 % 2 == 1);
		            this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') | (1 << 4)));
		}
		if (cfg.pinConfiguration13 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16InputPin13").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 5), 'i', cfg.pinConfiguration13 % 2 == 1);
		            this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') | (1 << 5)));
		}
		if (cfg.pinConfiguration14 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16InputPin14").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 6), 'i', cfg.pinConfiguration14 % 2 == 1);
		            this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') | (1 << 6)));
		}
		if (cfg.pinConfiguration15 > 1) {
		BrickletIO16InputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16InputPin15").as(BrickletIO16InputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 7), 'i', cfg.pinConfiguration15 % 2 == 1);
		            this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') | (1 << 7)));
		}
		if (cfg.pinConfiguration0 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16OutputPin0").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 0), 'o', cfg.pinConfiguration0 % 2 == 1);
		}
		if (cfg.pinConfiguration1 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16OutputPin1").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 1), 'o', cfg.pinConfiguration1 % 2 == 1);
		}
		if (cfg.pinConfiguration2 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16OutputPin2").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 2), 'o', cfg.pinConfiguration2 % 2 == 1);
		}
		if (cfg.pinConfiguration3 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16OutputPin3").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 3), 'o', cfg.pinConfiguration3 % 2 == 1);
		}
		if (cfg.pinConfiguration4 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16OutputPin4").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 4), 'o', cfg.pinConfiguration4 % 2 == 1);
		}
		if (cfg.pinConfiguration5 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16OutputPin5").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 5), 'o', cfg.pinConfiguration5 % 2 == 1);
		}
		if (cfg.pinConfiguration6 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16OutputPin6").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 6), 'o', cfg.pinConfiguration6 % 2 == 1);
		}
		if (cfg.pinConfiguration7 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16OutputPin7").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('a', (short)(1 << 7), 'o', cfg.pinConfiguration7 % 2 == 1);
		}
		if (cfg.pinConfiguration8 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16OutputPin8").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 0), 'o', cfg.pinConfiguration8 % 2 == 1);
		}
		if (cfg.pinConfiguration9 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16OutputPin9").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 1), 'o', cfg.pinConfiguration9 % 2 == 1);
		}
		if (cfg.pinConfiguration10 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16OutputPin10").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 2), 'o', cfg.pinConfiguration10 % 2 == 1);
		}
		if (cfg.pinConfiguration11 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16OutputPin11").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 3), 'o', cfg.pinConfiguration11 % 2 == 1);
		}
		if (cfg.pinConfiguration12 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16OutputPin12").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 4), 'o', cfg.pinConfiguration12 % 2 == 1);
		}
		if (cfg.pinConfiguration13 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16OutputPin13").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 5), 'o', cfg.pinConfiguration13 % 2 == 1);
		}
		if (cfg.pinConfiguration14 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16OutputPin14").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 6), 'o', cfg.pinConfiguration14 % 2 == 1);
		}
		if (cfg.pinConfiguration15 <= 1) {
		BrickletIO16OutputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO16OutputPin15").as(BrickletIO16OutputPinConfig.class);
		this.setPortConfiguration('b', (short)(1 << 7), 'o', cfg.pinConfiguration15 % 2 == 1);
		}
		if (cfg.pinConfiguration0 > 1) {
		BrickletIO16EdgeCountConfig channelCfg = getChannelConfigFn.apply("BrickletIO16EdgeCountPin0").as(BrickletIO16EdgeCountConfig.class);
		this.setEdgeCountConfig((short)(1 << 0), channelCfg.edgeType.shortValue(), channelCfg.debounce.shortValue());
		if(channelCfg.updateInterval > 0) {
    this.manualChannelUpdates.add(scheduler.scheduleWithFixedDelay(() -> {if(handler.getThing().getStatus() == ThingStatus.ONLINE) {handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIO16EdgeCountPin0"), RefreshType.REFRESH);}}, channelCfg.updateInterval, channelCfg.updateInterval, TimeUnit.MILLISECONDS));
}
		}
		if (cfg.pinConfiguration1 > 1) {
		BrickletIO16EdgeCountConfig channelCfg = getChannelConfigFn.apply("BrickletIO16EdgeCountPin1").as(BrickletIO16EdgeCountConfig.class);
		this.setEdgeCountConfig((short)(1 << 1), channelCfg.edgeType.shortValue(), channelCfg.debounce.shortValue());
		if(channelCfg.updateInterval > 0) {
    this.manualChannelUpdates.add(scheduler.scheduleWithFixedDelay(() -> {if(handler.getThing().getStatus() == ThingStatus.ONLINE) {handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIO16EdgeCountPin1"), RefreshType.REFRESH);}}, channelCfg.updateInterval, channelCfg.updateInterval, TimeUnit.MILLISECONDS));
}
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        listenerRegs.forEach(reg -> reg.toRemove.accept(reg.listener));

        BrickletIO16Config cfg = (BrickletIO16Config) config.as(BrickletIO16Config.class);
        if(cfg.pinConfiguration0 > 1) {
this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') & ~(1 << 0)));}
		if(cfg.pinConfiguration1 > 1) {
this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') & ~(1 << 1)));}
		if(cfg.pinConfiguration2 > 1) {
this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') & ~(1 << 2)));}
		if(cfg.pinConfiguration3 > 1) {
this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') & ~(1 << 3)));}
		if(cfg.pinConfiguration4 > 1) {
this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') & ~(1 << 4)));}
		if(cfg.pinConfiguration5 > 1) {
this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') & ~(1 << 5)));}
		if(cfg.pinConfiguration6 > 1) {
this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') & ~(1 << 6)));}
		if(cfg.pinConfiguration7 > 1) {
this.setPortInterrupt('a', (short)(this.getPortInterrupt('a') & ~(1 << 7)));}
		if(cfg.pinConfiguration8 > 1) {
this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') & ~(1 << 0)));}
		if(cfg.pinConfiguration9 > 1) {
this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') & ~(1 << 1)));}
		if(cfg.pinConfiguration10 > 1) {
this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') & ~(1 << 2)));}
		if(cfg.pinConfiguration11 > 1) {
this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') & ~(1 << 3)));}
		if(cfg.pinConfiguration12 > 1) {
this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') & ~(1 << 4)));}
		if(cfg.pinConfiguration13 > 1) {
this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') & ~(1 << 5)));}
		if(cfg.pinConfiguration14 > 1) {
this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') & ~(1 << 6)));}
		if(cfg.pinConfiguration15 > 1) {
this.setPortInterrupt('b', (short)(this.getPortInterrupt('b') & ~(1 << 7)));}
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletIO16Config cfg = (BrickletIO16Config) config.as(BrickletIO16Config.class);
        List<String> result = new ArrayList<String>();
        if (cfg.pinConfiguration0 > 1) {
                result.add("BrickletIO16InputPin0");
            }
		if (cfg.pinConfiguration1 > 1) {
                result.add("BrickletIO16InputPin1");
            }
		if (cfg.pinConfiguration2 > 1) {
                result.add("BrickletIO16InputPin2");
            }
		if (cfg.pinConfiguration3 > 1) {
                result.add("BrickletIO16InputPin3");
            }
		if (cfg.pinConfiguration4 > 1) {
                result.add("BrickletIO16InputPin4");
            }
		if (cfg.pinConfiguration5 > 1) {
                result.add("BrickletIO16InputPin5");
            }
		if (cfg.pinConfiguration6 > 1) {
                result.add("BrickletIO16InputPin6");
            }
		if (cfg.pinConfiguration7 > 1) {
                result.add("BrickletIO16InputPin7");
            }
		if (cfg.pinConfiguration8 > 1) {
                result.add("BrickletIO16InputPin8");
            }
		if (cfg.pinConfiguration9 > 1) {
                result.add("BrickletIO16InputPin9");
            }
		if (cfg.pinConfiguration10 > 1) {
                result.add("BrickletIO16InputPin10");
            }
		if (cfg.pinConfiguration11 > 1) {
                result.add("BrickletIO16InputPin11");
            }
		if (cfg.pinConfiguration12 > 1) {
                result.add("BrickletIO16InputPin12");
            }
		if (cfg.pinConfiguration13 > 1) {
                result.add("BrickletIO16InputPin13");
            }
		if (cfg.pinConfiguration14 > 1) {
                result.add("BrickletIO16InputPin14");
            }
		if (cfg.pinConfiguration15 > 1) {
                result.add("BrickletIO16InputPin15");
            }
		if (cfg.pinConfiguration0 <= 1) {
                result.add("BrickletIO16OutputPin0");
            }
		if (cfg.pinConfiguration1 <= 1) {
                result.add("BrickletIO16OutputPin1");
            }
		if (cfg.pinConfiguration2 <= 1) {
                result.add("BrickletIO16OutputPin2");
            }
		if (cfg.pinConfiguration3 <= 1) {
                result.add("BrickletIO16OutputPin3");
            }
		if (cfg.pinConfiguration4 <= 1) {
                result.add("BrickletIO16OutputPin4");
            }
		if (cfg.pinConfiguration5 <= 1) {
                result.add("BrickletIO16OutputPin5");
            }
		if (cfg.pinConfiguration6 <= 1) {
                result.add("BrickletIO16OutputPin6");
            }
		if (cfg.pinConfiguration7 <= 1) {
                result.add("BrickletIO16OutputPin7");
            }
		if (cfg.pinConfiguration8 <= 1) {
                result.add("BrickletIO16OutputPin8");
            }
		if (cfg.pinConfiguration9 <= 1) {
                result.add("BrickletIO16OutputPin9");
            }
		if (cfg.pinConfiguration10 <= 1) {
                result.add("BrickletIO16OutputPin10");
            }
		if (cfg.pinConfiguration11 <= 1) {
                result.add("BrickletIO16OutputPin11");
            }
		if (cfg.pinConfiguration12 <= 1) {
                result.add("BrickletIO16OutputPin12");
            }
		if (cfg.pinConfiguration13 <= 1) {
                result.add("BrickletIO16OutputPin13");
            }
		if (cfg.pinConfiguration14 <= 1) {
                result.add("BrickletIO16OutputPin14");
            }
		if (cfg.pinConfiguration15 <= 1) {
                result.add("BrickletIO16OutputPin15");
            }
		if (cfg.pinConfiguration0 <= 1) {
                result.add("BrickletIO16MonoflopPin0");
            }
		if (cfg.pinConfiguration1 <= 1) {
                result.add("BrickletIO16MonoflopPin1");
            }
		if (cfg.pinConfiguration2 <= 1) {
                result.add("BrickletIO16MonoflopPin2");
            }
		if (cfg.pinConfiguration3 <= 1) {
                result.add("BrickletIO16MonoflopPin3");
            }
		if (cfg.pinConfiguration4 <= 1) {
                result.add("BrickletIO16MonoflopPin4");
            }
		if (cfg.pinConfiguration5 <= 1) {
                result.add("BrickletIO16MonoflopPin5");
            }
		if (cfg.pinConfiguration6 <= 1) {
                result.add("BrickletIO16MonoflopPin6");
            }
		if (cfg.pinConfiguration7 <= 1) {
                result.add("BrickletIO16MonoflopPin7");
            }
		if (cfg.pinConfiguration8 <= 1) {
                result.add("BrickletIO16MonoflopPin8");
            }
		if (cfg.pinConfiguration9 <= 1) {
                result.add("BrickletIO16MonoflopPin9");
            }
		if (cfg.pinConfiguration10 <= 1) {
                result.add("BrickletIO16MonoflopPin10");
            }
		if (cfg.pinConfiguration11 <= 1) {
                result.add("BrickletIO16MonoflopPin11");
            }
		if (cfg.pinConfiguration12 <= 1) {
                result.add("BrickletIO16MonoflopPin12");
            }
		if (cfg.pinConfiguration13 <= 1) {
                result.add("BrickletIO16MonoflopPin13");
            }
		if (cfg.pinConfiguration14 <= 1) {
                result.add("BrickletIO16MonoflopPin14");
            }
		if (cfg.pinConfiguration15 <= 1) {
                result.add("BrickletIO16MonoflopPin15");
            }
		if (cfg.pinConfiguration0 > 1) {
                result.add("BrickletIO16EdgeCountPin0");
            }
		if (cfg.pinConfiguration1 > 1) {
                result.add("BrickletIO16EdgeCountPin1");
            }
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletIO16InputPin":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIO16InputPin"), "Input Value", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIO16InputPin")).withDescription("The logic level that is currently measured on the pin.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            case "BrickletIO16OutputPin":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIO16OutputPin"), "Output Value", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIO16OutputPin")).withDescription("The logic level that is currently set on the pin.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(false).build().toStateDescription()).build();
            case "BrickletIO16Monoflop":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIO16Monoflop"), "NOT USED", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIO16Monoflop")).withDescription("Triggers a monoflop as configured")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("TRIGGER", "Trigger")).build()).build();
            case "BrickletIO16EdgeCount":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIO16EdgeCount"), "Edge Count", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIO16EdgeCount")).withDescription("The current value of the edge counter for the selected channel")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge IO-16 Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("16-channel digital input/output").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletIO16InputPin0", new ChannelTypeUID("tinkerforge", "BrickletIO16InputPin")).withLabel("Input Value Pin 0/A0").build(), new ChannelDefinitionBuilder("BrickletIO16InputPin1", new ChannelTypeUID("tinkerforge", "BrickletIO16InputPin")).withLabel("Input Value Pin 1/A1").build(), new ChannelDefinitionBuilder("BrickletIO16InputPin2", new ChannelTypeUID("tinkerforge", "BrickletIO16InputPin")).withLabel("Input Value Pin 2/A2").build(), new ChannelDefinitionBuilder("BrickletIO16InputPin3", new ChannelTypeUID("tinkerforge", "BrickletIO16InputPin")).withLabel("Input Value Pin 3/A3").build(), new ChannelDefinitionBuilder("BrickletIO16InputPin4", new ChannelTypeUID("tinkerforge", "BrickletIO16InputPin")).withLabel("Input Value Pin 4/A4").build(), new ChannelDefinitionBuilder("BrickletIO16InputPin5", new ChannelTypeUID("tinkerforge", "BrickletIO16InputPin")).withLabel("Input Value Pin 5/A5").build(), new ChannelDefinitionBuilder("BrickletIO16InputPin6", new ChannelTypeUID("tinkerforge", "BrickletIO16InputPin")).withLabel("Input Value Pin 6/A6").build(), new ChannelDefinitionBuilder("BrickletIO16InputPin7", new ChannelTypeUID("tinkerforge", "BrickletIO16InputPin")).withLabel("Input Value Pin 7/A7").build(), new ChannelDefinitionBuilder("BrickletIO16InputPin8", new ChannelTypeUID("tinkerforge", "BrickletIO16InputPin")).withLabel("Input Value Pin 8/B0").build(), new ChannelDefinitionBuilder("BrickletIO16InputPin9", new ChannelTypeUID("tinkerforge", "BrickletIO16InputPin")).withLabel("Input Value Pin 9/B1").build(), new ChannelDefinitionBuilder("BrickletIO16InputPin10", new ChannelTypeUID("tinkerforge", "BrickletIO16InputPin")).withLabel("Input Value Pin 10/B2").build(), new ChannelDefinitionBuilder("BrickletIO16InputPin11", new ChannelTypeUID("tinkerforge", "BrickletIO16InputPin")).withLabel("Input Value Pin 11/B3").build(), new ChannelDefinitionBuilder("BrickletIO16InputPin12", new ChannelTypeUID("tinkerforge", "BrickletIO16InputPin")).withLabel("Input Value Pin 12/B4").build(), new ChannelDefinitionBuilder("BrickletIO16InputPin13", new ChannelTypeUID("tinkerforge", "BrickletIO16InputPin")).withLabel("Input Value Pin 13/B5").build(), new ChannelDefinitionBuilder("BrickletIO16InputPin14", new ChannelTypeUID("tinkerforge", "BrickletIO16InputPin")).withLabel("Input Value Pin 14/B6").build(), new ChannelDefinitionBuilder("BrickletIO16InputPin15", new ChannelTypeUID("tinkerforge", "BrickletIO16InputPin")).withLabel("Input Value Pin 15/B7").build(), new ChannelDefinitionBuilder("BrickletIO16OutputPin0", new ChannelTypeUID("tinkerforge", "BrickletIO16OutputPin")).withLabel("Output Value Pin 0/A0").build(), new ChannelDefinitionBuilder("BrickletIO16OutputPin1", new ChannelTypeUID("tinkerforge", "BrickletIO16OutputPin")).withLabel("Output Value Pin 1/A1").build(), new ChannelDefinitionBuilder("BrickletIO16OutputPin2", new ChannelTypeUID("tinkerforge", "BrickletIO16OutputPin")).withLabel("Output Value Pin 2/A2").build(), new ChannelDefinitionBuilder("BrickletIO16OutputPin3", new ChannelTypeUID("tinkerforge", "BrickletIO16OutputPin")).withLabel("Output Value Pin 3/A3").build(), new ChannelDefinitionBuilder("BrickletIO16OutputPin4", new ChannelTypeUID("tinkerforge", "BrickletIO16OutputPin")).withLabel("Output Value Pin 4/A4").build(), new ChannelDefinitionBuilder("BrickletIO16OutputPin5", new ChannelTypeUID("tinkerforge", "BrickletIO16OutputPin")).withLabel("Output Value Pin 5/A5").build(), new ChannelDefinitionBuilder("BrickletIO16OutputPin6", new ChannelTypeUID("tinkerforge", "BrickletIO16OutputPin")).withLabel("Output Value Pin 6/A6").build(), new ChannelDefinitionBuilder("BrickletIO16OutputPin7", new ChannelTypeUID("tinkerforge", "BrickletIO16OutputPin")).withLabel("Output Value Pin 7/A7").build(), new ChannelDefinitionBuilder("BrickletIO16OutputPin8", new ChannelTypeUID("tinkerforge", "BrickletIO16OutputPin")).withLabel("Output Value Pin 8/B0").build(), new ChannelDefinitionBuilder("BrickletIO16OutputPin9", new ChannelTypeUID("tinkerforge", "BrickletIO16OutputPin")).withLabel("Output Value Pin 9/B1").build(), new ChannelDefinitionBuilder("BrickletIO16OutputPin10", new ChannelTypeUID("tinkerforge", "BrickletIO16OutputPin")).withLabel("Output Value Pin 10/B2").build(), new ChannelDefinitionBuilder("BrickletIO16OutputPin11", new ChannelTypeUID("tinkerforge", "BrickletIO16OutputPin")).withLabel("Output Value Pin 11/B3").build(), new ChannelDefinitionBuilder("BrickletIO16OutputPin12", new ChannelTypeUID("tinkerforge", "BrickletIO16OutputPin")).withLabel("Output Value Pin 12/B4").build(), new ChannelDefinitionBuilder("BrickletIO16OutputPin13", new ChannelTypeUID("tinkerforge", "BrickletIO16OutputPin")).withLabel("Output Value Pin 13/B5").build(), new ChannelDefinitionBuilder("BrickletIO16OutputPin14", new ChannelTypeUID("tinkerforge", "BrickletIO16OutputPin")).withLabel("Output Value Pin 14/B6").build(), new ChannelDefinitionBuilder("BrickletIO16OutputPin15", new ChannelTypeUID("tinkerforge", "BrickletIO16OutputPin")).withLabel("Output Value Pin 15/B7").build(), new ChannelDefinitionBuilder("BrickletIO16MonoflopPin0", new ChannelTypeUID("tinkerforge", "BrickletIO16Monoflop")).withLabel("Monoflop Pin 0/A0").build(), new ChannelDefinitionBuilder("BrickletIO16MonoflopPin1", new ChannelTypeUID("tinkerforge", "BrickletIO16Monoflop")).withLabel("Monoflop Pin 1/A1").build(), new ChannelDefinitionBuilder("BrickletIO16MonoflopPin2", new ChannelTypeUID("tinkerforge", "BrickletIO16Monoflop")).withLabel("Monoflop Pin 2/A2").build(), new ChannelDefinitionBuilder("BrickletIO16MonoflopPin3", new ChannelTypeUID("tinkerforge", "BrickletIO16Monoflop")).withLabel("Monoflop Pin 3/A3").build(), new ChannelDefinitionBuilder("BrickletIO16MonoflopPin4", new ChannelTypeUID("tinkerforge", "BrickletIO16Monoflop")).withLabel("Monoflop Pin 4/A4").build(), new ChannelDefinitionBuilder("BrickletIO16MonoflopPin5", new ChannelTypeUID("tinkerforge", "BrickletIO16Monoflop")).withLabel("Monoflop Pin 5/A5").build(), new ChannelDefinitionBuilder("BrickletIO16MonoflopPin6", new ChannelTypeUID("tinkerforge", "BrickletIO16Monoflop")).withLabel("Monoflop Pin 6/A6").build(), new ChannelDefinitionBuilder("BrickletIO16MonoflopPin7", new ChannelTypeUID("tinkerforge", "BrickletIO16Monoflop")).withLabel("Monoflop Pin 7/A7").build(), new ChannelDefinitionBuilder("BrickletIO16MonoflopPin8", new ChannelTypeUID("tinkerforge", "BrickletIO16Monoflop")).withLabel("Monoflop Pin 8/B0").build(), new ChannelDefinitionBuilder("BrickletIO16MonoflopPin9", new ChannelTypeUID("tinkerforge", "BrickletIO16Monoflop")).withLabel("Monoflop Pin 9/B1").build(), new ChannelDefinitionBuilder("BrickletIO16MonoflopPin10", new ChannelTypeUID("tinkerforge", "BrickletIO16Monoflop")).withLabel("Monoflop Pin 10/B2").build(), new ChannelDefinitionBuilder("BrickletIO16MonoflopPin11", new ChannelTypeUID("tinkerforge", "BrickletIO16Monoflop")).withLabel("Monoflop Pin 11/B3").build(), new ChannelDefinitionBuilder("BrickletIO16MonoflopPin12", new ChannelTypeUID("tinkerforge", "BrickletIO16Monoflop")).withLabel("Monoflop Pin 12/B4").build(), new ChannelDefinitionBuilder("BrickletIO16MonoflopPin13", new ChannelTypeUID("tinkerforge", "BrickletIO16Monoflop")).withLabel("Monoflop Pin 13/B5").build(), new ChannelDefinitionBuilder("BrickletIO16MonoflopPin14", new ChannelTypeUID("tinkerforge", "BrickletIO16Monoflop")).withLabel("Monoflop Pin 14/B6").build(), new ChannelDefinitionBuilder("BrickletIO16MonoflopPin15", new ChannelTypeUID("tinkerforge", "BrickletIO16Monoflop")).withLabel("Monoflop Pin 15/B7").build(), new ChannelDefinitionBuilder("BrickletIO16EdgeCountPin0", new ChannelTypeUID("tinkerforge", "BrickletIO16EdgeCount")).withLabel("Edge Count Pin 0/A0").build(), new ChannelDefinitionBuilder("BrickletIO16EdgeCountPin1", new ChannelTypeUID("tinkerforge", "BrickletIO16EdgeCount")).withLabel("Edge Count Pin 1/A1").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletio16":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("pinConfiguration0", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 0/A0. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 0/A0").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration1", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 1/A1. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 1/A1").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration2", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 2/A2. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 2/A2").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration3", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 3/A3. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 3/A3").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration4", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 4/A4. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 4/A4").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration5", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 5/A5. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 5/A5").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration6", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 6/A6. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 6/A6").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration7", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 7/A7. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 7/A7").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration8", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 8/B0. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 8/B0").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration9", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 9/B1. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 9/B1").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration10", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 10/B2. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 10/B2").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration11", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 11/B3. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 11/B3").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration12", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 12/B4. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 12/B4").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration13", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 13/B5. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 13/B5").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration14", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 14/B6. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 14/B6").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration15", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 15/B7. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 15/B7").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletIO16InputPin":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletIO16OutputPin":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletIO16Monoflop":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("monoflopDuration", Type.INTEGER).withDefault("1000").withDescription("The time (in ms) that the pin should hold the configured value.").withLabel("Monoflop Duration").withUnit("ms").withAdvanced(true).withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(4294967295L)).build(), ConfigDescriptionParameterBuilder.create("monoflopValue", Type.BOOLEAN).withDefault("true").withDescription("The desired value of the specified channel. Activated means relay closed and Deactivated means relay open.").withLabel("Monoflop Value").withAdvanced(true).build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletIO16EdgeCount":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("edgeType", Type.INTEGER).withDefault("0").withDescription("The edge type parameter configures if rising edges, falling edges or both are counted.").withLabel("Edge Type").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Rising"), new ParameterOption("1", "Falling"), new ParameterOption("2", "Both"))).build(), ConfigDescriptionParameterBuilder.create("debounce", Type.INTEGER).withDefault("100").withDescription("The debounce time in ms.").withLabel("Debounce Time").build(), ConfigDescriptionParameterBuilder.create("resetOnRead", Type.BOOLEAN).withDefault("false").withDescription("Enabling this will reset the edge counter after OpenHAB reads its value. Use this if you want relative edge counts per update.").withLabel("Reset Edge Count On Update").build(), ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIO16Config cfg = (BrickletIO16Config) config.as(BrickletIO16Config.class);
        switch(channel) {
            case "BrickletIO16InputPin0": {
                   BrickletIO16InputPinConfig channelCfg = channelConfig.as(BrickletIO16InputPinConfig.class);
                   {
            short value = this.getPort('a');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16InputPin0Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16InputPin1": {
                   BrickletIO16InputPinConfig channelCfg = channelConfig.as(BrickletIO16InputPinConfig.class);
                   {
            short value = this.getPort('a');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16InputPin1Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16InputPin2": {
                   BrickletIO16InputPinConfig channelCfg = channelConfig.as(BrickletIO16InputPinConfig.class);
                   {
            short value = this.getPort('a');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16InputPin2Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16InputPin3": {
                   BrickletIO16InputPinConfig channelCfg = channelConfig.as(BrickletIO16InputPinConfig.class);
                   {
            short value = this.getPort('a');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16InputPin3Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16InputPin4": {
                   BrickletIO16InputPinConfig channelCfg = channelConfig.as(BrickletIO16InputPinConfig.class);
                   {
            short value = this.getPort('a');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16InputPin4Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16InputPin5": {
                   BrickletIO16InputPinConfig channelCfg = channelConfig.as(BrickletIO16InputPinConfig.class);
                   {
            short value = this.getPort('a');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16InputPin5Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16InputPin6": {
                   BrickletIO16InputPinConfig channelCfg = channelConfig.as(BrickletIO16InputPinConfig.class);
                   {
            short value = this.getPort('a');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16InputPin6Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16InputPin7": {
                   BrickletIO16InputPinConfig channelCfg = channelConfig.as(BrickletIO16InputPinConfig.class);
                   {
            short value = this.getPort('a');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16InputPin7Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16InputPin8": {
                   BrickletIO16InputPinConfig channelCfg = channelConfig.as(BrickletIO16InputPinConfig.class);
                   {
            short value = this.getPort('b');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16InputPin8Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16InputPin9": {
                   BrickletIO16InputPinConfig channelCfg = channelConfig.as(BrickletIO16InputPinConfig.class);
                   {
            short value = this.getPort('b');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16InputPin9Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16InputPin10": {
                   BrickletIO16InputPinConfig channelCfg = channelConfig.as(BrickletIO16InputPinConfig.class);
                   {
            short value = this.getPort('b');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16InputPin10Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16InputPin11": {
                   BrickletIO16InputPinConfig channelCfg = channelConfig.as(BrickletIO16InputPinConfig.class);
                   {
            short value = this.getPort('b');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16InputPin11Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16InputPin12": {
                   BrickletIO16InputPinConfig channelCfg = channelConfig.as(BrickletIO16InputPinConfig.class);
                   {
            short value = this.getPort('b');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16InputPin12Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16InputPin13": {
                   BrickletIO16InputPinConfig channelCfg = channelConfig.as(BrickletIO16InputPinConfig.class);
                   {
            short value = this.getPort('b');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16InputPin13Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16InputPin14": {
                   BrickletIO16InputPinConfig channelCfg = channelConfig.as(BrickletIO16InputPinConfig.class);
                   {
            short value = this.getPort('b');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16InputPin14Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16InputPin15": {
                   BrickletIO16InputPinConfig channelCfg = channelConfig.as(BrickletIO16InputPinConfig.class);
                   {
            short value = this.getPort('b');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16InputPin15Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16OutputPin0": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   {
            short value = this.getPort('a');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16OutputPin0Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16OutputPin1": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   {
            short value = this.getPort('a');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16OutputPin1Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16OutputPin2": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   {
            short value = this.getPort('a');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16OutputPin2Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16OutputPin3": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   {
            short value = this.getPort('a');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16OutputPin3Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16OutputPin4": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   {
            short value = this.getPort('a');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16OutputPin4Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16OutputPin5": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   {
            short value = this.getPort('a');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16OutputPin5Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16OutputPin6": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   {
            short value = this.getPort('a');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16OutputPin6Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16OutputPin7": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   {
            short value = this.getPort('a');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16OutputPin7Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16OutputPin8": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   {
            short value = this.getPort('b');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16OutputPin8Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16OutputPin9": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   {
            short value = this.getPort('b');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16OutputPin9Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16OutputPin10": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   {
            short value = this.getPort('b');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16OutputPin10Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16OutputPin11": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   {
            short value = this.getPort('b');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16OutputPin11Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16OutputPin12": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   {
            short value = this.getPort('b');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16OutputPin12Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16OutputPin13": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   {
            short value = this.getPort('b');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16OutputPin13Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16OutputPin14": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   {
            short value = this.getPort('b');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16OutputPin14Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16OutputPin15": {
                   BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                   {
            short value = this.getPort('b');
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16OutputPin15Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16MonoflopPin0": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   {
            BrickletIO16.PortMonoflop value = this.getPortMonoflop('a', (short)0);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16MonoflopPin0Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16MonoflopPin1": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   {
            BrickletIO16.PortMonoflop value = this.getPortMonoflop('a', (short)1);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16MonoflopPin1Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16MonoflopPin2": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   {
            BrickletIO16.PortMonoflop value = this.getPortMonoflop('a', (short)2);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16MonoflopPin2Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16MonoflopPin3": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   {
            BrickletIO16.PortMonoflop value = this.getPortMonoflop('a', (short)3);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16MonoflopPin3Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16MonoflopPin4": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   {
            BrickletIO16.PortMonoflop value = this.getPortMonoflop('a', (short)4);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16MonoflopPin4Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16MonoflopPin5": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   {
            BrickletIO16.PortMonoflop value = this.getPortMonoflop('a', (short)5);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16MonoflopPin5Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16MonoflopPin6": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   {
            BrickletIO16.PortMonoflop value = this.getPortMonoflop('a', (short)6);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16MonoflopPin6Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16MonoflopPin7": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   {
            BrickletIO16.PortMonoflop value = this.getPortMonoflop('a', (short)7);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16MonoflopPin7Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16MonoflopPin8": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   {
            BrickletIO16.PortMonoflop value = this.getPortMonoflop('b', (short)0);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16MonoflopPin8Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16MonoflopPin9": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   {
            BrickletIO16.PortMonoflop value = this.getPortMonoflop('b', (short)1);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16MonoflopPin9Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16MonoflopPin10": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   {
            BrickletIO16.PortMonoflop value = this.getPortMonoflop('b', (short)2);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16MonoflopPin10Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16MonoflopPin11": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   {
            BrickletIO16.PortMonoflop value = this.getPortMonoflop('b', (short)3);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16MonoflopPin11Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16MonoflopPin12": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   {
            BrickletIO16.PortMonoflop value = this.getPortMonoflop('b', (short)4);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16MonoflopPin12Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16MonoflopPin13": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   {
            BrickletIO16.PortMonoflop value = this.getPortMonoflop('b', (short)5);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16MonoflopPin13Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16MonoflopPin14": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   {
            BrickletIO16.PortMonoflop value = this.getPortMonoflop('b', (short)6);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16MonoflopPin14Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16MonoflopPin15": {
                   BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                   {
            BrickletIO16.PortMonoflop value = this.getPortMonoflop('b', (short)7);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16MonoflopPin15Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16EdgeCountPin0": {
                   BrickletIO16EdgeCountConfig channelCfg = channelConfig.as(BrickletIO16EdgeCountConfig.class);
                   {
            long value = this.getEdgeCount((short)0, channelCfg.resetOnRead);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16EdgeCountPin0Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO16EdgeCountPin1": {
                   BrickletIO16EdgeCountConfig channelCfg = channelConfig.as(BrickletIO16EdgeCountConfig.class);
                   {
            long value = this.getEdgeCount((short)1, channelCfg.resetOnRead);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO16EdgeCountPin1Getter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = new ArrayList<SetterRefresh>();
        BrickletIO16Config cfg = (BrickletIO16Config) config.as(BrickletIO16Config.class);
        switch(channel) {
            case "BrickletIO16OutputPin0":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('a', (short)(1 << 0), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIO16OutputPin1":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('a', (short)(1 << 1), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIO16OutputPin2":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('a', (short)(1 << 2), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIO16OutputPin3":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('a', (short)(1 << 3), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIO16OutputPin4":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('a', (short)(1 << 4), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIO16OutputPin5":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('a', (short)(1 << 5), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIO16OutputPin6":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('a', (short)(1 << 6), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIO16OutputPin7":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('a', (short)(1 << 7), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIO16OutputPin8":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('b', (short)(1 << 0), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIO16OutputPin9":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('b', (short)(1 << 1), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIO16OutputPin10":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('b', (short)(1 << 2), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIO16OutputPin11":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('b', (short)(1 << 3), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIO16OutputPin12":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('b', (short)(1 << 4), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIO16OutputPin13":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('b', (short)(1 << 5), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIO16OutputPin14":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('b', (short)(1 << 6), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIO16OutputPin15":
                if (command instanceof OnOffType) {
                    BrickletIO16OutputPinConfig channelCfg = channelConfig.as(BrickletIO16OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues('b', (short)(1 << 7), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIO16MonoflopPin0":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('a', (short)(1 << 0), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIO16OutputPin0", 0));
                break;
            case "BrickletIO16MonoflopPin1":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('a', (short)(1 << 1), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIO16OutputPin1", 0));
                break;
            case "BrickletIO16MonoflopPin2":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('a', (short)(1 << 2), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIO16OutputPin2", 0));
                break;
            case "BrickletIO16MonoflopPin3":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('a', (short)(1 << 3), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIO16OutputPin3", 0));
                break;
            case "BrickletIO16MonoflopPin4":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('a', (short)(1 << 4), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIO16OutputPin4", 0));
                break;
            case "BrickletIO16MonoflopPin5":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('a', (short)(1 << 5), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIO16OutputPin5", 0));
                break;
            case "BrickletIO16MonoflopPin6":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('a', (short)(1 << 6), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIO16OutputPin6", 0));
                break;
            case "BrickletIO16MonoflopPin7":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('a', (short)(1 << 7), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIO16OutputPin7", 0));
                break;
            case "BrickletIO16MonoflopPin8":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('b', (short)(1 << 0), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIO16OutputPin8", 0));
                break;
            case "BrickletIO16MonoflopPin9":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('b', (short)(1 << 1), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIO16OutputPin9", 0));
                break;
            case "BrickletIO16MonoflopPin10":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('b', (short)(1 << 2), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIO16OutputPin10", 0));
                break;
            case "BrickletIO16MonoflopPin11":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('b', (short)(1 << 3), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIO16OutputPin11", 0));
                break;
            case "BrickletIO16MonoflopPin12":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('b', (short)(1 << 4), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIO16OutputPin12", 0));
                break;
            case "BrickletIO16MonoflopPin13":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('b', (short)(1 << 5), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIO16OutputPin13", 0));
                break;
            case "BrickletIO16MonoflopPin14":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('b', (short)(1 << 6), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIO16OutputPin14", 0));
                break;
            case "BrickletIO16MonoflopPin15":
                if (command instanceof StringType) {
                    BrickletIO16MonoflopConfig channelCfg = channelConfig.as(BrickletIO16MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setPortMonoflop('b', (short)(1 << 7), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIO16OutputPin15", 0));
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin0Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 0)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin1Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 1)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin2Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 2)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin3Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 3)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin4Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 4)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin5Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 5)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin6Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 6)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin7Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 7)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin8Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 0)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin9Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 1)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin10Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 2)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin11Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 3)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin12Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 4)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin13Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 5)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin14Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 6)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin15Callback0(char port, short interruptMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 7)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin0Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 0)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin1Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 1)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin2Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 2)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin3Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 3)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin4Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 4)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin5Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 5)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin6Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 6)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin7Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 7)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin8Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 0)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin9Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 1)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin10Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 2)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin11Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 3)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin12Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 4)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin13Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 5)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin14Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 6)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin15Callback0(char port, short selectionMask, short valueMask, BrickletIO16Config cfg) {
        return (valueMask & (1 << 7)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin0Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 0)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin1Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 1)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin2Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 2)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin3Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 3)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin4Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 4)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin5Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 5)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin6Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 6)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin7Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 7)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin8Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 0)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin9Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 1)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin10Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 2)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin11Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 3)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin12Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 4)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin13Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 5)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin14Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 6)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16InputPin15Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 7)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin0Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 0)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin1Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 1)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin2Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 2)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin3Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 3)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin4Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 4)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin5Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 5)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin6Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 6)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin7Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 7)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin8Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 0)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin9Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 1)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin10Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 2)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin11Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 3)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin12Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 4)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin13Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 5)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin14Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 6)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16OutputPin15Getter0(short value, BrickletIO16Config cfg) {
        return (value & (1 << 7)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16MonoflopPin0Getter0(BrickletIO16.PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16MonoflopPin1Getter0(BrickletIO16.PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16MonoflopPin2Getter0(BrickletIO16.PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16MonoflopPin3Getter0(BrickletIO16.PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16MonoflopPin4Getter0(BrickletIO16.PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16MonoflopPin5Getter0(BrickletIO16.PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16MonoflopPin6Getter0(BrickletIO16.PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16MonoflopPin7Getter0(BrickletIO16.PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16MonoflopPin8Getter0(BrickletIO16.PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16MonoflopPin9Getter0(BrickletIO16.PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16MonoflopPin10Getter0(BrickletIO16.PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16MonoflopPin11Getter0(BrickletIO16.PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16MonoflopPin12Getter0(BrickletIO16.PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16MonoflopPin13Getter0(BrickletIO16.PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16MonoflopPin14Getter0(BrickletIO16.PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16MonoflopPin15Getter0(BrickletIO16.PortMonoflop value, BrickletIO16Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16EdgeCountPin0Getter0(long value, BrickletIO16Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO16EdgeCountPin1Getter0(long value, BrickletIO16Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }

}