/* ***********************************************************
 * This file was automatically generated on 2020-02-28.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.function.Consumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingStatus;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;
import org.eclipse.smarthome.core.library.types.StringType;

import com.tinkerforge.BrickletIO4;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletIO4Wrapper extends BrickletIO4 implements StandardFlashable, DeviceWrapper {
    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletIO4.DEVICE_DISPLAY_NAME, "brickletio4", BrickletIO4.DEVICE_IDENTIFIER, BrickletIO4Wrapper.class, BrickletIO4Actions.class, "2.0.1", false);

    public BrickletIO4Wrapper(String uid, IPConnection ipcon) {
        super(uid, ipcon);
    }

    private List<ScheduledFuture<?>> manualChannelUpdates = new ArrayList<ScheduledFuture<?>>();
    private List<ListenerReg> listenerRegs = new ArrayList<ListenerReg>();

    public void cancelManualUpdates() {
        manualChannelUpdates.forEach(f -> f.cancel(true));
    }

    public <T> T reg(T listener, Consumer<T> toRemove) {
        listenerRegs.add(new ListenerReg<T>(listener, toRemove));
        return listener;
    }

    
    private final Logger logger = LoggerFactory.getLogger(BrickletIO4Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletIO4Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        this.setResponseExpectedAll(true);
        BrickletIO4Config cfg = (BrickletIO4Config) config.as(BrickletIO4Config.class);
        if(cfg.pinConfiguration0 > 1) {
this.addInterruptListener(this.reg((interruptMask, valueMask) -> {if((interruptMask & (1 << 0)) > 0) {updateStateFn.accept("BrickletIO4InputPin0", transformBrickletIO4InputPin0Callback0(interruptMask, valueMask, cfg));}}, this::removeInterruptListener));}
		if(cfg.pinConfiguration1 > 1) {
this.addInterruptListener(this.reg((interruptMask, valueMask) -> {if((interruptMask & (1 << 1)) > 0) {updateStateFn.accept("BrickletIO4InputPin1", transformBrickletIO4InputPin1Callback0(interruptMask, valueMask, cfg));}}, this::removeInterruptListener));}
		if(cfg.pinConfiguration2 > 1) {
this.addInterruptListener(this.reg((interruptMask, valueMask) -> {if((interruptMask & (1 << 2)) > 0) {updateStateFn.accept("BrickletIO4InputPin2", transformBrickletIO4InputPin2Callback0(interruptMask, valueMask, cfg));}}, this::removeInterruptListener));}
		if(cfg.pinConfiguration3 > 1) {
this.addInterruptListener(this.reg((interruptMask, valueMask) -> {if((interruptMask & (1 << 3)) > 0) {updateStateFn.accept("BrickletIO4InputPin3", transformBrickletIO4InputPin3Callback0(interruptMask, valueMask, cfg));}}, this::removeInterruptListener));}
		if(cfg.pinConfiguration0 <= 1) {
this.addMonoflopDoneListener(this.reg((selectionMask, valueMask) -> {if((selectionMask & (1 << 0)) > 0) {updateStateFn.accept("BrickletIO4OutputPin0", transformBrickletIO4OutputPin0Callback0(selectionMask, valueMask, cfg));}}, this::removeMonoflopDoneListener));}
		if(cfg.pinConfiguration1 <= 1) {
this.addMonoflopDoneListener(this.reg((selectionMask, valueMask) -> {if((selectionMask & (1 << 1)) > 0) {updateStateFn.accept("BrickletIO4OutputPin1", transformBrickletIO4OutputPin1Callback0(selectionMask, valueMask, cfg));}}, this::removeMonoflopDoneListener));}
		if(cfg.pinConfiguration2 <= 1) {
this.addMonoflopDoneListener(this.reg((selectionMask, valueMask) -> {if((selectionMask & (1 << 2)) > 0) {updateStateFn.accept("BrickletIO4OutputPin2", transformBrickletIO4OutputPin2Callback0(selectionMask, valueMask, cfg));}}, this::removeMonoflopDoneListener));}
		if(cfg.pinConfiguration3 <= 1) {
this.addMonoflopDoneListener(this.reg((selectionMask, valueMask) -> {if((selectionMask & (1 << 3)) > 0) {updateStateFn.accept("BrickletIO4OutputPin3", transformBrickletIO4OutputPin3Callback0(selectionMask, valueMask, cfg));}}, this::removeMonoflopDoneListener));}
        
		if (cfg.pinConfiguration0 > 1) {
		BrickletIO4InputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO4InputPin0").as(BrickletIO4InputPinConfig.class);
		this.setInterrupt((short)(this.getInterrupt() | (1 << 0)));
		            this.setConfiguration((short)(1 << 0), 'i', cfg.pinConfiguration0 % 2 == 1);
		}
		if (cfg.pinConfiguration1 > 1) {
		BrickletIO4InputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO4InputPin1").as(BrickletIO4InputPinConfig.class);
		this.setInterrupt((short)(this.getInterrupt() | (1 << 1)));
		            this.setConfiguration((short)(1 << 1), 'i', cfg.pinConfiguration1 % 2 == 1);
		}
		if (cfg.pinConfiguration2 > 1) {
		BrickletIO4InputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO4InputPin2").as(BrickletIO4InputPinConfig.class);
		this.setInterrupt((short)(this.getInterrupt() | (1 << 2)));
		            this.setConfiguration((short)(1 << 2), 'i', cfg.pinConfiguration2 % 2 == 1);
		}
		if (cfg.pinConfiguration3 > 1) {
		BrickletIO4InputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO4InputPin3").as(BrickletIO4InputPinConfig.class);
		this.setInterrupt((short)(this.getInterrupt() | (1 << 3)));
		            this.setConfiguration((short)(1 << 3), 'i', cfg.pinConfiguration3 % 2 == 1);
		}
		if (cfg.pinConfiguration0 <= 1) {
		BrickletIO4OutputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO4OutputPin0").as(BrickletIO4OutputPinConfig.class);
		this.setConfiguration((short)(1 << 0), 'o', cfg.pinConfiguration0 % 2 == 1);
		}
		if (cfg.pinConfiguration1 <= 1) {
		BrickletIO4OutputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO4OutputPin1").as(BrickletIO4OutputPinConfig.class);
		this.setConfiguration((short)(1 << 1), 'o', cfg.pinConfiguration1 % 2 == 1);
		}
		if (cfg.pinConfiguration2 <= 1) {
		BrickletIO4OutputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO4OutputPin2").as(BrickletIO4OutputPinConfig.class);
		this.setConfiguration((short)(1 << 2), 'o', cfg.pinConfiguration2 % 2 == 1);
		}
		if (cfg.pinConfiguration3 <= 1) {
		BrickletIO4OutputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO4OutputPin3").as(BrickletIO4OutputPinConfig.class);
		this.setConfiguration((short)(1 << 3), 'o', cfg.pinConfiguration3 % 2 == 1);
		}
		if (cfg.pinConfiguration0 > 1) {
		BrickletIO4EdgeCountConfig channelCfg = getChannelConfigFn.apply("BrickletIO4EdgeCountPin0").as(BrickletIO4EdgeCountConfig.class);
		this.setEdgeCountConfig((short)(1 << 0), channelCfg.edgeType.shortValue(), channelCfg.debounce.shortValue());
		if(channelCfg.updateInterval > 0) {
    this.manualChannelUpdates.add(scheduler.scheduleWithFixedDelay(() -> {if(handler.getThing().getStatus() == ThingStatus.ONLINE) {handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIO4EdgeCountPin0"), RefreshType.REFRESH);}}, channelCfg.updateInterval, channelCfg.updateInterval, TimeUnit.MILLISECONDS));
}
		}
		if (cfg.pinConfiguration1 > 1) {
		BrickletIO4EdgeCountConfig channelCfg = getChannelConfigFn.apply("BrickletIO4EdgeCountPin1").as(BrickletIO4EdgeCountConfig.class);
		this.setEdgeCountConfig((short)(1 << 1), channelCfg.edgeType.shortValue(), channelCfg.debounce.shortValue());
		if(channelCfg.updateInterval > 0) {
    this.manualChannelUpdates.add(scheduler.scheduleWithFixedDelay(() -> {if(handler.getThing().getStatus() == ThingStatus.ONLINE) {handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIO4EdgeCountPin1"), RefreshType.REFRESH);}}, channelCfg.updateInterval, channelCfg.updateInterval, TimeUnit.MILLISECONDS));
}
		}
		if (cfg.pinConfiguration2 > 1) {
		BrickletIO4EdgeCountConfig channelCfg = getChannelConfigFn.apply("BrickletIO4EdgeCountPin2").as(BrickletIO4EdgeCountConfig.class);
		this.setEdgeCountConfig((short)(1 << 2), channelCfg.edgeType.shortValue(), channelCfg.debounce.shortValue());
		if(channelCfg.updateInterval > 0) {
    this.manualChannelUpdates.add(scheduler.scheduleWithFixedDelay(() -> {if(handler.getThing().getStatus() == ThingStatus.ONLINE) {handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIO4EdgeCountPin2"), RefreshType.REFRESH);}}, channelCfg.updateInterval, channelCfg.updateInterval, TimeUnit.MILLISECONDS));
}
		}
		if (cfg.pinConfiguration3 > 1) {
		BrickletIO4EdgeCountConfig channelCfg = getChannelConfigFn.apply("BrickletIO4EdgeCountPin3").as(BrickletIO4EdgeCountConfig.class);
		this.setEdgeCountConfig((short)(1 << 3), channelCfg.edgeType.shortValue(), channelCfg.debounce.shortValue());
		if(channelCfg.updateInterval > 0) {
    this.manualChannelUpdates.add(scheduler.scheduleWithFixedDelay(() -> {if(handler.getThing().getStatus() == ThingStatus.ONLINE) {handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIO4EdgeCountPin3"), RefreshType.REFRESH);}}, channelCfg.updateInterval, channelCfg.updateInterval, TimeUnit.MILLISECONDS));
}
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        listenerRegs.forEach(reg -> reg.toRemove.accept(reg.listener));

        BrickletIO4Config cfg = (BrickletIO4Config) config.as(BrickletIO4Config.class);
        if(cfg.pinConfiguration0 > 1) {
this.setInterrupt((short)(this.getInterrupt() & ~(1 << 0)));}
		if(cfg.pinConfiguration1 > 1) {
this.setInterrupt((short)(this.getInterrupt() & ~(1 << 1)));}
		if(cfg.pinConfiguration2 > 1) {
this.setInterrupt((short)(this.getInterrupt() & ~(1 << 2)));}
		if(cfg.pinConfiguration3 > 1) {
this.setInterrupt((short)(this.getInterrupt() & ~(1 << 3)));}
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletIO4Config cfg = (BrickletIO4Config) config.as(BrickletIO4Config.class);
        List<String> result = new ArrayList<String>();
        if (cfg.pinConfiguration0 > 1) {
                result.add("BrickletIO4InputPin0");
            }
		if (cfg.pinConfiguration1 > 1) {
                result.add("BrickletIO4InputPin1");
            }
		if (cfg.pinConfiguration2 > 1) {
                result.add("BrickletIO4InputPin2");
            }
		if (cfg.pinConfiguration3 > 1) {
                result.add("BrickletIO4InputPin3");
            }
		if (cfg.pinConfiguration0 <= 1) {
                result.add("BrickletIO4OutputPin0");
            }
		if (cfg.pinConfiguration1 <= 1) {
                result.add("BrickletIO4OutputPin1");
            }
		if (cfg.pinConfiguration2 <= 1) {
                result.add("BrickletIO4OutputPin2");
            }
		if (cfg.pinConfiguration3 <= 1) {
                result.add("BrickletIO4OutputPin3");
            }
		if (cfg.pinConfiguration0 <= 1) {
                result.add("BrickletIO4MonoflopPin0");
            }
		if (cfg.pinConfiguration1 <= 1) {
                result.add("BrickletIO4MonoflopPin1");
            }
		if (cfg.pinConfiguration2 <= 1) {
                result.add("BrickletIO4MonoflopPin2");
            }
		if (cfg.pinConfiguration3 <= 1) {
                result.add("BrickletIO4MonoflopPin3");
            }
		if (cfg.pinConfiguration0 > 1) {
                result.add("BrickletIO4EdgeCountPin0");
            }
		if (cfg.pinConfiguration1 > 1) {
                result.add("BrickletIO4EdgeCountPin1");
            }
		if (cfg.pinConfiguration2 > 1) {
                result.add("BrickletIO4EdgeCountPin2");
            }
		if (cfg.pinConfiguration3 > 1) {
                result.add("BrickletIO4EdgeCountPin3");
            }
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletIO4InputPin":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIO4InputPin"), "Input Value", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIO4InputPin")).withDescription("The logic level that is currently measured on the pin.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            case "BrickletIO4OutputPin":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIO4OutputPin"), "Output Value", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIO4OutputPin")).withDescription("The logic level that is currently set on the pin.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(false).build().toStateDescription()).build();
            case "BrickletIO4Monoflop":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIO4Monoflop"), "NOT USED", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIO4Monoflop")).withDescription("Triggers a monoflop as configured")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("TRIGGER", "Trigger")).build()).build();
            case "BrickletIO4EdgeCount":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIO4EdgeCount"), "Edge Count", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIO4EdgeCount")).withDescription("The current value of the edge counter for the selected channel")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge IO-4 Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("4-channel digital input/output").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletIO4InputPin0", new ChannelTypeUID("tinkerforge", "BrickletIO4InputPin")).withLabel("Input Value Pin 0").build(), new ChannelDefinitionBuilder("BrickletIO4InputPin1", new ChannelTypeUID("tinkerforge", "BrickletIO4InputPin")).withLabel("Input Value Pin 1").build(), new ChannelDefinitionBuilder("BrickletIO4InputPin2", new ChannelTypeUID("tinkerforge", "BrickletIO4InputPin")).withLabel("Input Value Pin 2").build(), new ChannelDefinitionBuilder("BrickletIO4InputPin3", new ChannelTypeUID("tinkerforge", "BrickletIO4InputPin")).withLabel("Input Value Pin 3").build(), new ChannelDefinitionBuilder("BrickletIO4OutputPin0", new ChannelTypeUID("tinkerforge", "BrickletIO4OutputPin")).withLabel("Output Value Pin 0").build(), new ChannelDefinitionBuilder("BrickletIO4OutputPin1", new ChannelTypeUID("tinkerforge", "BrickletIO4OutputPin")).withLabel("Output Value Pin 1").build(), new ChannelDefinitionBuilder("BrickletIO4OutputPin2", new ChannelTypeUID("tinkerforge", "BrickletIO4OutputPin")).withLabel("Output Value Pin 2").build(), new ChannelDefinitionBuilder("BrickletIO4OutputPin3", new ChannelTypeUID("tinkerforge", "BrickletIO4OutputPin")).withLabel("Output Value Pin 3").build(), new ChannelDefinitionBuilder("BrickletIO4MonoflopPin0", new ChannelTypeUID("tinkerforge", "BrickletIO4Monoflop")).withLabel("Monoflop Pin 0").build(), new ChannelDefinitionBuilder("BrickletIO4MonoflopPin1", new ChannelTypeUID("tinkerforge", "BrickletIO4Monoflop")).withLabel("Monoflop Pin 1").build(), new ChannelDefinitionBuilder("BrickletIO4MonoflopPin2", new ChannelTypeUID("tinkerforge", "BrickletIO4Monoflop")).withLabel("Monoflop Pin 2").build(), new ChannelDefinitionBuilder("BrickletIO4MonoflopPin3", new ChannelTypeUID("tinkerforge", "BrickletIO4Monoflop")).withLabel("Monoflop Pin 3").build(), new ChannelDefinitionBuilder("BrickletIO4EdgeCountPin0", new ChannelTypeUID("tinkerforge", "BrickletIO4EdgeCount")).withLabel("Edge Count Pin 0").build(), new ChannelDefinitionBuilder("BrickletIO4EdgeCountPin1", new ChannelTypeUID("tinkerforge", "BrickletIO4EdgeCount")).withLabel("Edge Count Pin 1").build(), new ChannelDefinitionBuilder("BrickletIO4EdgeCountPin2", new ChannelTypeUID("tinkerforge", "BrickletIO4EdgeCount")).withLabel("Edge Count Pin 2").build(), new ChannelDefinitionBuilder("BrickletIO4EdgeCountPin3", new ChannelTypeUID("tinkerforge", "BrickletIO4EdgeCount")).withLabel("Edge Count Pin 3").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletio4":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("pinConfiguration0", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 0. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 0").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration1", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 1. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 1").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration2", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 2. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 2").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration3", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 3. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 3").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletIO4InputPin":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletIO4OutputPin":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletIO4Monoflop":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("monoflopDuration", Type.INTEGER).withDefault("1000").withDescription("The time (in ms) that the pin should hold the configured value.").withLabel("Monoflop Duration").withUnit("ms").withAdvanced(true).withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(4294967295L)).build(), ConfigDescriptionParameterBuilder.create("monoflopValue", Type.BOOLEAN).withDefault("true").withDescription("The desired value of the specified channel. Activated means relay closed and Deactivated means relay open.").withLabel("Monoflop Value").withAdvanced(true).build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletIO4EdgeCount":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("edgeType", Type.INTEGER).withDefault("0").withDescription("The edge type parameter configures if rising edges, falling edges or both are counted.").withLabel("Edge Type").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Rising"), new ParameterOption("1", "Falling"), new ParameterOption("2", "Both"))).build(), ConfigDescriptionParameterBuilder.create("debounce", Type.INTEGER).withDefault("100").withDescription("The debounce time in ms.").withLabel("Debounce Time").build(), ConfigDescriptionParameterBuilder.create("resetOnRead", Type.BOOLEAN).withDefault("false").withDescription("Enabling this will reset the edge counter after OpenHAB reads its value. Use this if you want relative edge counts per update.").withLabel("Reset Edge Count On Update").build(), ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIO4Config cfg = (BrickletIO4Config) config.as(BrickletIO4Config.class);
        switch(channel) {
            case "BrickletIO4InputPin0": {
                   BrickletIO4InputPinConfig channelCfg = channelConfig.as(BrickletIO4InputPinConfig.class);
                   {
            short value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4InputPin0Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO4InputPin1": {
                   BrickletIO4InputPinConfig channelCfg = channelConfig.as(BrickletIO4InputPinConfig.class);
                   {
            short value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4InputPin1Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO4InputPin2": {
                   BrickletIO4InputPinConfig channelCfg = channelConfig.as(BrickletIO4InputPinConfig.class);
                   {
            short value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4InputPin2Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO4InputPin3": {
                   BrickletIO4InputPinConfig channelCfg = channelConfig.as(BrickletIO4InputPinConfig.class);
                   {
            short value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4InputPin3Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO4OutputPin0": {
                   BrickletIO4OutputPinConfig channelCfg = channelConfig.as(BrickletIO4OutputPinConfig.class);
                   {
            short value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4OutputPin0Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO4OutputPin1": {
                   BrickletIO4OutputPinConfig channelCfg = channelConfig.as(BrickletIO4OutputPinConfig.class);
                   {
            short value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4OutputPin1Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO4OutputPin2": {
                   BrickletIO4OutputPinConfig channelCfg = channelConfig.as(BrickletIO4OutputPinConfig.class);
                   {
            short value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4OutputPin2Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO4OutputPin3": {
                   BrickletIO4OutputPinConfig channelCfg = channelConfig.as(BrickletIO4OutputPinConfig.class);
                   {
            short value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4OutputPin3Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO4MonoflopPin0": {
                   BrickletIO4MonoflopConfig channelCfg = channelConfig.as(BrickletIO4MonoflopConfig.class);
                   {
            BrickletIO4.Monoflop value = this.getMonoflop((short)0);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4MonoflopPin0Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO4MonoflopPin1": {
                   BrickletIO4MonoflopConfig channelCfg = channelConfig.as(BrickletIO4MonoflopConfig.class);
                   {
            BrickletIO4.Monoflop value = this.getMonoflop((short)1);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4MonoflopPin1Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO4MonoflopPin2": {
                   BrickletIO4MonoflopConfig channelCfg = channelConfig.as(BrickletIO4MonoflopConfig.class);
                   {
            BrickletIO4.Monoflop value = this.getMonoflop((short)2);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4MonoflopPin2Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO4MonoflopPin3": {
                   BrickletIO4MonoflopConfig channelCfg = channelConfig.as(BrickletIO4MonoflopConfig.class);
                   {
            BrickletIO4.Monoflop value = this.getMonoflop((short)3);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4MonoflopPin3Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO4EdgeCountPin0": {
                   BrickletIO4EdgeCountConfig channelCfg = channelConfig.as(BrickletIO4EdgeCountConfig.class);
                   {
            long value = this.getEdgeCount((short)0, channelCfg.resetOnRead);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4EdgeCountPin0Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO4EdgeCountPin1": {
                   BrickletIO4EdgeCountConfig channelCfg = channelConfig.as(BrickletIO4EdgeCountConfig.class);
                   {
            long value = this.getEdgeCount((short)1, channelCfg.resetOnRead);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4EdgeCountPin1Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO4EdgeCountPin2": {
                   BrickletIO4EdgeCountConfig channelCfg = channelConfig.as(BrickletIO4EdgeCountConfig.class);
                   {
            long value = this.getEdgeCount((short)2, channelCfg.resetOnRead);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4EdgeCountPin2Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO4EdgeCountPin3": {
                   BrickletIO4EdgeCountConfig channelCfg = channelConfig.as(BrickletIO4EdgeCountConfig.class);
                   {
            long value = this.getEdgeCount((short)3, channelCfg.resetOnRead);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4EdgeCountPin3Getter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = new ArrayList<SetterRefresh>();
        BrickletIO4Config cfg = (BrickletIO4Config) config.as(BrickletIO4Config.class);
        switch(channel) {
            case "BrickletIO4OutputPin0":
                if (command instanceof OnOffType) {
                    BrickletIO4OutputPinConfig channelCfg = channelConfig.as(BrickletIO4OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues((short)(1 << 0), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIO4OutputPin1":
                if (command instanceof OnOffType) {
                    BrickletIO4OutputPinConfig channelCfg = channelConfig.as(BrickletIO4OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues((short)(1 << 1), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIO4OutputPin2":
                if (command instanceof OnOffType) {
                    BrickletIO4OutputPinConfig channelCfg = channelConfig.as(BrickletIO4OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues((short)(1 << 2), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIO4OutputPin3":
                if (command instanceof OnOffType) {
                    BrickletIO4OutputPinConfig channelCfg = channelConfig.as(BrickletIO4OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues((short)(1 << 3), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIO4MonoflopPin0":
                if (command instanceof StringType) {
                    BrickletIO4MonoflopConfig channelCfg = channelConfig.as(BrickletIO4MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop((short)(1 << 0), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIO4OutputPin0", 0));
                break;
            case "BrickletIO4MonoflopPin1":
                if (command instanceof StringType) {
                    BrickletIO4MonoflopConfig channelCfg = channelConfig.as(BrickletIO4MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop((short)(1 << 1), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIO4OutputPin1", 0));
                break;
            case "BrickletIO4MonoflopPin2":
                if (command instanceof StringType) {
                    BrickletIO4MonoflopConfig channelCfg = channelConfig.as(BrickletIO4MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop((short)(1 << 2), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIO4OutputPin2", 0));
                break;
            case "BrickletIO4MonoflopPin3":
                if (command instanceof StringType) {
                    BrickletIO4MonoflopConfig channelCfg = channelConfig.as(BrickletIO4MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop((short)(1 << 3), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIO4OutputPin3", 0));
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletIO4InputPin0Callback0(short interruptMask, short valueMask, BrickletIO4Config cfg) {
        return (valueMask & (1 << 0)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4InputPin1Callback0(short interruptMask, short valueMask, BrickletIO4Config cfg) {
        return (valueMask & (1 << 1)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4InputPin2Callback0(short interruptMask, short valueMask, BrickletIO4Config cfg) {
        return (valueMask & (1 << 2)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4InputPin3Callback0(short interruptMask, short valueMask, BrickletIO4Config cfg) {
        return (valueMask & (1 << 3)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4OutputPin0Callback0(short selectionMask, short valueMask, BrickletIO4Config cfg) {
        return (valueMask & (1 << 0)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4OutputPin1Callback0(short selectionMask, short valueMask, BrickletIO4Config cfg) {
        return (valueMask & (1 << 1)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4OutputPin2Callback0(short selectionMask, short valueMask, BrickletIO4Config cfg) {
        return (valueMask & (1 << 2)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4OutputPin3Callback0(short selectionMask, short valueMask, BrickletIO4Config cfg) {
        return (valueMask & (1 << 3)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4InputPin0Getter0(short value, BrickletIO4Config cfg) {
        return (value & (1 << 0)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4InputPin1Getter0(short value, BrickletIO4Config cfg) {
        return (value & (1 << 1)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4InputPin2Getter0(short value, BrickletIO4Config cfg) {
        return (value & (1 << 2)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4InputPin3Getter0(short value, BrickletIO4Config cfg) {
        return (value & (1 << 3)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4OutputPin0Getter0(short value, BrickletIO4Config cfg) {
        return (value & (1 << 0)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4OutputPin1Getter0(short value, BrickletIO4Config cfg) {
        return (value & (1 << 1)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4OutputPin2Getter0(short value, BrickletIO4Config cfg) {
        return (value & (1 << 2)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4OutputPin3Getter0(short value, BrickletIO4Config cfg) {
        return (value & (1 << 3)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4MonoflopPin0Getter0(BrickletIO4.Monoflop value, BrickletIO4Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4MonoflopPin1Getter0(BrickletIO4.Monoflop value, BrickletIO4Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4MonoflopPin2Getter0(BrickletIO4.Monoflop value, BrickletIO4Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4MonoflopPin3Getter0(BrickletIO4.Monoflop value, BrickletIO4Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4EdgeCountPin0Getter0(long value, BrickletIO4Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4EdgeCountPin1Getter0(long value, BrickletIO4Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4EdgeCountPin2Getter0(long value, BrickletIO4Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4EdgeCountPin3Getter0(long value, BrickletIO4Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }

}