/* ***********************************************************
 * This file was automatically generated on 2020-02-28.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.function.Consumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingStatus;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;
import org.eclipse.smarthome.core.library.types.DecimalType;

import com.tinkerforge.BrickletIndustrialAnalogOut;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletIndustrialAnalogOutWrapper extends BrickletIndustrialAnalogOut implements StandardFlashable, DeviceWrapper {
    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletIndustrialAnalogOut.DEVICE_DISPLAY_NAME, "brickletindustrialanalogout", BrickletIndustrialAnalogOut.DEVICE_IDENTIFIER, BrickletIndustrialAnalogOutWrapper.class, BrickletIndustrialAnalogOutActions.class, "2.0.0", false);

    public BrickletIndustrialAnalogOutWrapper(String uid, IPConnection ipcon) {
        super(uid, ipcon);
    }

    private List<ScheduledFuture<?>> manualChannelUpdates = new ArrayList<ScheduledFuture<?>>();
    private List<ListenerReg> listenerRegs = new ArrayList<ListenerReg>();

    public void cancelManualUpdates() {
        manualChannelUpdates.forEach(f -> f.cancel(true));
    }

    public <T> T reg(T listener, Consumer<T> toRemove) {
        listenerRegs.add(new ListenerReg<T>(listener, toRemove));
        return listener;
    }

    
    private final Logger logger = LoggerFactory.getLogger(BrickletIndustrialAnalogOutWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletIndustrialAnalogOutWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        this.setResponseExpectedAll(true);
        BrickletIndustrialAnalogOutConfig cfg = (BrickletIndustrialAnalogOutConfig) config.as(BrickletIndustrialAnalogOutConfig.class);
        
        this.setConfiguration(cfg.voltageRange.shortValue(), cfg.currentRange.shortValue());
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        listenerRegs.forEach(reg -> reg.toRemove.accept(reg.listener));

        BrickletIndustrialAnalogOutConfig cfg = (BrickletIndustrialAnalogOutConfig) config.as(BrickletIndustrialAnalogOutConfig.class);
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletIndustrialAnalogOutConfig cfg = (BrickletIndustrialAnalogOutConfig) config.as(BrickletIndustrialAnalogOutConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletIndustrialAnalogOutEnabled");
		if (cfg.controlVoltage == 0) {
                result.add("BrickletIndustrialAnalogOutCurrent");
            }
		if (cfg.controlVoltage == 1) {
                result.add("BrickletIndustrialAnalogOutVoltage");
            }
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletIndustrialAnalogOutEnabled":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIndustrialAnalogOutEnabled"), "Output Enabled", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIndustrialAnalogOutEnabled")).withDescription("Enables/disables the output of voltage and current.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(false).build().toStateDescription()).build();
            case "BrickletIndustrialAnalogOutVoltage":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIndustrialAnalogOutVoltage"), "Output Voltage", "Number:ElectricPotential").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIndustrialAnalogOutVoltage")).withDescription("The output voltage in V. The output voltage and output current are linked. Changing the output voltage also changes the output current.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(10)).withPattern("%.3f %unit%").withReadOnly(false).build().toStateDescription()).build();
            case "BrickletIndustrialAnalogOutCurrent":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIndustrialAnalogOutCurrent"), "Output Current", "Number:ElectricCurrent").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIndustrialAnalogOutCurrent")).withDescription("The output current in A. The output current and output voltage are linked. Changing the output current also changes the output voltage.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(0.024)).withPattern("%.6f %unit%").withReadOnly(false).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Industrial Analog Out Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Generates configurable DC voltage and current, 0V to 10V and 4mA to 20mA").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletIndustrialAnalogOutEnabled", new ChannelTypeUID("tinkerforge", "BrickletIndustrialAnalogOutEnabled")).withLabel("Output Enabled").build(), new ChannelDefinitionBuilder("BrickletIndustrialAnalogOutCurrent", new ChannelTypeUID("tinkerforge", "BrickletIndustrialAnalogOutCurrent")).withLabel("Output Current").build(), new ChannelDefinitionBuilder("BrickletIndustrialAnalogOutVoltage", new ChannelTypeUID("tinkerforge", "BrickletIndustrialAnalogOutVoltage")).withLabel("Output Voltage").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletindustrialanalogout":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("controlVoltage", Type.INTEGER).withDefault("1").withDescription("Sets the output configuration. As the output voltage and current level depend on each other, only one can be controlled at the same time.").withLabel("Output Configuration").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "Current"), new ParameterOption("1", "Voltage"))).build(), ConfigDescriptionParameterBuilder.create("voltageRange", Type.INTEGER).withDefault("1").withDescription("Configures the voltage range. The resolution will always be 12 bit. This means, that the precision is higher with a smaller range.").withLabel("Voltage Range").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "0 To 5V"), new ParameterOption("1", "0 To 10V"))).build(), ConfigDescriptionParameterBuilder.create("currentRange", Type.INTEGER).withDefault("0").withDescription("Configures the current range. The resolution will always be 12 bit. This means, that the precision is higher with a smaller range.").withLabel("Current Range").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "4 To 20mA"), new ParameterOption("1", "0 To 20mA"), new ParameterOption("2", "0 To 24mA"))).build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletIndustrialAnalogOutEnabled":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletIndustrialAnalogOutVoltage":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletIndustrialAnalogOutCurrent":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIndustrialAnalogOutConfig cfg = (BrickletIndustrialAnalogOutConfig) config.as(BrickletIndustrialAnalogOutConfig.class);
        switch(channel) {
            case "BrickletIndustrialAnalogOutEnabled": {
                   BrickletIndustrialAnalogOutEnabledConfig channelCfg = channelConfig.as(BrickletIndustrialAnalogOutEnabledConfig.class);
                   {
            boolean value = this.isEnabled();
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialAnalogOutEnabledGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialAnalogOutCurrent": {
                   BrickletIndustrialAnalogOutCurrentConfig channelCfg = channelConfig.as(BrickletIndustrialAnalogOutCurrentConfig.class);
                   {
            int value = this.getCurrent();
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialAnalogOutCurrentGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialAnalogOutVoltage": {
                   BrickletIndustrialAnalogOutVoltageConfig channelCfg = channelConfig.as(BrickletIndustrialAnalogOutVoltageConfig.class);
                   {
            int value = this.getVoltage();
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialAnalogOutVoltageGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletIndustrialAnalogOutConfig cfg = (BrickletIndustrialAnalogOutConfig) config.as(BrickletIndustrialAnalogOutConfig.class);
        switch(channel) {
            case "BrickletIndustrialAnalogOutEnabled":
                if (command instanceof OnOffType) {
                    BrickletIndustrialAnalogOutEnabledConfig channelCfg = channelConfig.as(BrickletIndustrialAnalogOutEnabledConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    if(cmd == OnOffType.ON) {
    this.enable();
}
                }
        
if (command instanceof OnOffType) {
                    BrickletIndustrialAnalogOutEnabledConfig channelCfg = channelConfig.as(BrickletIndustrialAnalogOutEnabledConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    if(cmd == OnOffType.OFF) {
    this.disable();
}
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType, OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIndustrialAnalogOutCurrent":
                if (command instanceof Number) {
                    BrickletIndustrialAnalogOutCurrentConfig channelCfg = channelConfig.as(BrickletIndustrialAnalogOutCurrentConfig.class);
                    Number cmd = (Number) command;
                    this.setCurrent((int)(cmd.doubleValue() * 1000000.0));
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of Number.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIndustrialAnalogOutVoltage":
                if (command instanceof Number) {
                    BrickletIndustrialAnalogOutVoltageConfig channelCfg = channelConfig.as(BrickletIndustrialAnalogOutVoltageConfig.class);
                    Number cmd = (Number) command;
                    this.setVoltage((int)(cmd.doubleValue() * 1000.0));
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of Number.", command.getClass().getName(), channel);
                }
                
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletIndustrialAnalogOutEnabledGetter0(boolean value, BrickletIndustrialAnalogOutConfig cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialAnalogOutCurrentGetter0(int value, BrickletIndustrialAnalogOutConfig cfg) {
        return new QuantityType(value / 1000000.0, SmartHomeUnits.AMPERE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialAnalogOutVoltageGetter0(int value, BrickletIndustrialAnalogOutConfig cfg) {
        return new QuantityType(value / 1000.0, SmartHomeUnits.VOLT);
    }

}