package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.smarthome.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.util.Map;
import java.util.HashMap;

import com.tinkerforge.TinkerforgeException;
import com.tinkerforge.BrickletIndustrialDigitalOut4;

@ThingActionsScope(name = "tinkerforge")
@NonNullByDefault
public class BrickletIndustrialDigitalOut4Actions implements ThingActions {

    private @Nullable DeviceHandler handler;

    @Override
    public void setThingHandler(@Nullable ThingHandler handler) { this.handler = (DeviceHandler) handler; }

    @Override
    public @Nullable ThingHandler getThingHandler() { return handler; }

        @RuleAction(label = "Set Value")
    public void brickletIndustrialDigitalOut4SetValue(
            @ActionInput(name = "valueMask") int valueMask) throws TinkerforgeException {
        ((BrickletIndustrialDigitalOut4Wrapper)this.handler.getDevice()).setValue(valueMask);
        if(handler.getThing().getChannel(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4OutputPin0")) != null){
	this.handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4OutputPin0"), RefreshType.REFRESH);
}
if(handler.getThing().getChannel(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4OutputPin1")) != null){
	this.handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4OutputPin1"), RefreshType.REFRESH);
}
if(handler.getThing().getChannel(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4OutputPin2")) != null){
	this.handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4OutputPin2"), RefreshType.REFRESH);
}
if(handler.getThing().getChannel(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4OutputPin3")) != null){
	this.handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4OutputPin3"), RefreshType.REFRESH);
}
if(handler.getThing().getChannel(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4MonoflopPin0")) != null){
	this.handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4MonoflopPin0"), RefreshType.REFRESH);
}
if(handler.getThing().getChannel(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4MonoflopPin1")) != null){
	this.handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4MonoflopPin1"), RefreshType.REFRESH);
}
if(handler.getThing().getChannel(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4MonoflopPin2")) != null){
	this.handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4MonoflopPin2"), RefreshType.REFRESH);
}
if(handler.getThing().getChannel(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4MonoflopPin3")) != null){
	this.handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4MonoflopPin3"), RefreshType.REFRESH);
}
    }

    public static void brickletIndustrialDigitalOut4SetValue(@Nullable ThingActions actions, int valueMask) throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDigitalOut4Actions) {
            ((BrickletIndustrialDigitalOut4Actions) actions).brickletIndustrialDigitalOut4SetValue(valueMask);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDigitalOut4Actions class.");
        }
    }

    @RuleAction(label = "Set Selected Values")
    public void brickletIndustrialDigitalOut4SetSelectedValues(
            @ActionInput(name = "selectionMask") int selectionMask,
            @ActionInput(name = "valueMask") int valueMask) throws TinkerforgeException {
        ((BrickletIndustrialDigitalOut4Wrapper)this.handler.getDevice()).setSelectedValues(selectionMask, valueMask);
        if(handler.getThing().getChannel(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4OutputPin0")) != null){
	this.handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4OutputPin0"), RefreshType.REFRESH);
}
if(handler.getThing().getChannel(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4OutputPin1")) != null){
	this.handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4OutputPin1"), RefreshType.REFRESH);
}
if(handler.getThing().getChannel(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4OutputPin2")) != null){
	this.handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4OutputPin2"), RefreshType.REFRESH);
}
if(handler.getThing().getChannel(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4OutputPin3")) != null){
	this.handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4OutputPin3"), RefreshType.REFRESH);
}
if(handler.getThing().getChannel(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4MonoflopPin0")) != null){
	this.handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4MonoflopPin0"), RefreshType.REFRESH);
}
if(handler.getThing().getChannel(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4MonoflopPin1")) != null){
	this.handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4MonoflopPin1"), RefreshType.REFRESH);
}
if(handler.getThing().getChannel(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4MonoflopPin2")) != null){
	this.handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4MonoflopPin2"), RefreshType.REFRESH);
}
if(handler.getThing().getChannel(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4MonoflopPin3")) != null){
	this.handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4MonoflopPin3"), RefreshType.REFRESH);
}
    }

    public static void brickletIndustrialDigitalOut4SetSelectedValues(@Nullable ThingActions actions, int selectionMask, int valueMask) throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDigitalOut4Actions) {
            ((BrickletIndustrialDigitalOut4Actions) actions).brickletIndustrialDigitalOut4SetSelectedValues(selectionMask, valueMask);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDigitalOut4Actions class.");
        }
    }

    @RuleAction(label = "Set Monoflop")
    public void brickletIndustrialDigitalOut4SetMonoflop(
            @ActionInput(name = "selectionMask") int selectionMask,
            @ActionInput(name = "valueMask") int valueMask,
            @ActionInput(name = "time") long time) throws TinkerforgeException {
        ((BrickletIndustrialDigitalOut4Wrapper)this.handler.getDevice()).setMonoflop(selectionMask, valueMask, time);
        if(handler.getThing().getChannel(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4OutputPin0")) != null){
	this.handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4OutputPin0"), RefreshType.REFRESH);
}
if(handler.getThing().getChannel(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4OutputPin1")) != null){
	this.handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4OutputPin1"), RefreshType.REFRESH);
}
if(handler.getThing().getChannel(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4OutputPin2")) != null){
	this.handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4OutputPin2"), RefreshType.REFRESH);
}
if(handler.getThing().getChannel(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4OutputPin3")) != null){
	this.handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4OutputPin3"), RefreshType.REFRESH);
}
if(handler.getThing().getChannel(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4MonoflopPin0")) != null){
	this.handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4MonoflopPin0"), RefreshType.REFRESH);
}
if(handler.getThing().getChannel(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4MonoflopPin1")) != null){
	this.handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4MonoflopPin1"), RefreshType.REFRESH);
}
if(handler.getThing().getChannel(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4MonoflopPin2")) != null){
	this.handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4MonoflopPin2"), RefreshType.REFRESH);
}
if(handler.getThing().getChannel(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4MonoflopPin3")) != null){
	this.handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalOut4MonoflopPin3"), RefreshType.REFRESH);
}
    }

    public static void brickletIndustrialDigitalOut4SetMonoflop(@Nullable ThingActions actions, int selectionMask, int valueMask, long time) throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDigitalOut4Actions) {
            ((BrickletIndustrialDigitalOut4Actions) actions).brickletIndustrialDigitalOut4SetMonoflop(selectionMask, valueMask, time);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDigitalOut4Actions class.");
        }
    }

    @RuleAction(label = "Get Value")
    public @ActionOutput(name = "valueMask", type="int")
           Map<String, Object> brickletIndustrialDigitalOut4GetValue(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletIndustrialDigitalOut4Wrapper)this.handler.getDevice()).getValue();
        
        result.put("valueMask", value);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDigitalOut4GetValue(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDigitalOut4Actions) {
            return ((BrickletIndustrialDigitalOut4Actions) actions).brickletIndustrialDigitalOut4GetValue();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDigitalOut4Actions class.");
        }
    }

    @RuleAction(label = "Get Monoflop")
    public @ActionOutput(name = "value", type="int")
           @ActionOutput(name = "time", type="long")
           @ActionOutput(name = "timeRemaining", type="long")
           Map<String, Object> brickletIndustrialDigitalOut4GetMonoflop(
            @ActionInput(name = "pin") short pin) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        BrickletIndustrialDigitalOut4.Monoflop value = ((BrickletIndustrialDigitalOut4Wrapper)this.handler.getDevice()).getMonoflop(pin);
        
        result.put("value", value.value);
        result.put("time", value.time);
        result.put("timeRemaining", value.timeRemaining);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDigitalOut4GetMonoflop(@Nullable ThingActions actions, short pin) throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDigitalOut4Actions) {
            return ((BrickletIndustrialDigitalOut4Actions) actions).brickletIndustrialDigitalOut4GetMonoflop(pin);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDigitalOut4Actions class.");
        }
    }

    @RuleAction(label = "Get Identity")
    public @ActionOutput(name = "uid", type="String")
           @ActionOutput(name = "connectedUid", type="String")
           @ActionOutput(name = "position", type="char")
           @ActionOutput(name = "hardwareVersion", type="short[]")
           @ActionOutput(name = "firmwareVersion", type="short[]")
           @ActionOutput(name = "deviceIdentifier", type="int")
           Map<String, Object> brickletIndustrialDigitalOut4GetIdentity(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        BrickletIndustrialDigitalOut4.Identity value = ((BrickletIndustrialDigitalOut4Wrapper)this.handler.getDevice()).getIdentity();
        
        result.put("uid", value.uid);
        result.put("connectedUid", value.connectedUid);
        result.put("position", value.position);
        result.put("hardwareVersion", value.hardwareVersion);
        result.put("firmwareVersion", value.firmwareVersion);
        result.put("deviceIdentifier", value.deviceIdentifier);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDigitalOut4GetIdentity(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDigitalOut4Actions) {
            return ((BrickletIndustrialDigitalOut4Actions) actions).brickletIndustrialDigitalOut4GetIdentity();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDigitalOut4Actions class.");
        }
    }
}
