/* ***********************************************************
 * This file was automatically generated on 2020-02-28.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.function.Consumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingStatus;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

import com.tinkerforge.BrickletIndustrialDual020mA;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletIndustrialDual020mAWrapper extends BrickletIndustrialDual020mA implements StandardFlashable, DeviceWrapper {
    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletIndustrialDual020mA.DEVICE_DISPLAY_NAME, "brickletindustrialdual020ma", BrickletIndustrialDual020mA.DEVICE_IDENTIFIER, BrickletIndustrialDual020mAWrapper.class, BrickletIndustrialDual020mAActions.class, "2.0.0", false);

    public BrickletIndustrialDual020mAWrapper(String uid, IPConnection ipcon) {
        super(uid, ipcon);
    }

    private List<ScheduledFuture<?>> manualChannelUpdates = new ArrayList<ScheduledFuture<?>>();
    private List<ListenerReg> listenerRegs = new ArrayList<ListenerReg>();

    public void cancelManualUpdates() {
        manualChannelUpdates.forEach(f -> f.cancel(true));
    }

    public <T> T reg(T listener, Consumer<T> toRemove) {
        listenerRegs.add(new ListenerReg<T>(listener, toRemove));
        return listener;
    }

    
    private final Logger logger = LoggerFactory.getLogger(BrickletIndustrialDual020mAWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletIndustrialDual020mAWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        this.setResponseExpectedAll(true);
        BrickletIndustrialDual020mAConfig cfg = (BrickletIndustrialDual020mAConfig) config.as(BrickletIndustrialDual020mAConfig.class);
        this.addCurrentListener(this.reg((sensor, current) -> {if(sensor == 0) {updateStateFn.accept("BrickletIndustrialDual020mACurrentSensor0", transformBrickletIndustrialDual020mACurrentSensor0Callback0(sensor, current, cfg));}}, this::removeCurrentListener));
		this.addCurrentListener(this.reg((sensor, current) -> {if(sensor == 1) {updateStateFn.accept("BrickletIndustrialDual020mACurrentSensor1", transformBrickletIndustrialDual020mACurrentSensor1Callback0(sensor, current, cfg));}}, this::removeCurrentListener));
        this.setSampleRate(cfg.sampleRate.shortValue());
		{
		BrickletIndustrialDual020mACurrentConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialDual020mACurrentSensor0").as(BrickletIndustrialDual020mACurrentConfig.class);
		this.setCurrentCallbackPeriod((short)0, channelCfg.updateInterval);
		}
		{
		BrickletIndustrialDual020mACurrentConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialDual020mACurrentSensor1").as(BrickletIndustrialDual020mACurrentConfig.class);
		this.setCurrentCallbackPeriod((short)1, channelCfg.updateInterval);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        listenerRegs.forEach(reg -> reg.toRemove.accept(reg.listener));

        BrickletIndustrialDual020mAConfig cfg = (BrickletIndustrialDual020mAConfig) config.as(BrickletIndustrialDual020mAConfig.class);
        this.setCurrentCallbackPeriod((short)0, 0);
		this.setCurrentCallbackPeriod((short)1, 0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletIndustrialDual020mAConfig cfg = (BrickletIndustrialDual020mAConfig) config.as(BrickletIndustrialDual020mAConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletIndustrialDual020mACurrentSensor0");
		result.add("BrickletIndustrialDual020mACurrentSensor1");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletIndustrialDual020mACurrent":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIndustrialDual020mACurrent"), "NOT USED", "Number:ElectricCurrent").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIndustrialDual020mACurrent")).withDescription("Measured current between 0 and 0.022505322A (22.5mA)")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(0.022505322)).withPattern("%.6f %unit%").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Industrial Dual 0-20mA Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures two DC currents between 0mA and 20mA (IEC 60381-1)").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletIndustrialDual020mACurrentSensor0", new ChannelTypeUID("tinkerforge", "BrickletIndustrialDual020mACurrent")).withLabel("Current Sensor 0").build(), new ChannelDefinitionBuilder("BrickletIndustrialDual020mACurrentSensor1", new ChannelTypeUID("tinkerforge", "BrickletIndustrialDual020mACurrent")).withLabel("Current Sensor 1").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletindustrialdual020ma":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("sampleRate", Type.INTEGER).withDefault("3").withDescription("The sample rate to either 240, 60, 15 or 4 samples per second. The resolution for the rates is 12, 14, 16 and 18 bit respectively.").withLabel("Sample Rate").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "240 SPS"), new ParameterOption("1", "60 SPS"), new ParameterOption("2", "15 SPS"), new ParameterOption("3", "4 SPS"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletIndustrialDual020mACurrent":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIndustrialDual020mAConfig cfg = (BrickletIndustrialDual020mAConfig) config.as(BrickletIndustrialDual020mAConfig.class);
        switch(channel) {
            case "BrickletIndustrialDual020mACurrentSensor0": {
                   BrickletIndustrialDual020mACurrentConfig channelCfg = channelConfig.as(BrickletIndustrialDual020mACurrentConfig.class);
                   {
            int value = this.getCurrent((short)0);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialDual020mACurrentSensor0Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialDual020mACurrentSensor1": {
                   BrickletIndustrialDual020mACurrentConfig channelCfg = channelConfig.as(BrickletIndustrialDual020mACurrentConfig.class);
                   {
            int value = this.getCurrent((short)1);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialDual020mACurrentSensor1Getter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletIndustrialDual020mAConfig cfg = (BrickletIndustrialDual020mAConfig) config.as(BrickletIndustrialDual020mAConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDual020mACurrentSensor0Callback0(short sensor, int current, BrickletIndustrialDual020mAConfig cfg) {
        return new QuantityType<>(current / 1000000000.0, SmartHomeUnits.AMPERE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDual020mACurrentSensor1Callback0(short sensor, int current, BrickletIndustrialDual020mAConfig cfg) {
        return new QuantityType<>(current / 1000000000.0, SmartHomeUnits.AMPERE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDual020mACurrentSensor0Getter0(int value, BrickletIndustrialDual020mAConfig cfg) {
        return new QuantityType<>(value / 1000000000.0, SmartHomeUnits.AMPERE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDual020mACurrentSensor1Getter0(int value, BrickletIndustrialDual020mAConfig cfg) {
        return new QuantityType<>(value / 1000000000.0, SmartHomeUnits.AMPERE);
    }

}