/* ***********************************************************
 * This file was automatically generated on 2020-02-28.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.function.Consumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingStatus;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.StringType;

import com.tinkerforge.BrickletIsolator;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletIsolatorWrapper extends BrickletIsolator implements CoMCUFlashable, DeviceWrapper {
    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletIsolator.DEVICE_DISPLAY_NAME, "brickletisolator", BrickletIsolator.DEVICE_IDENTIFIER, BrickletIsolatorWrapper.class, BrickletIsolatorActions.class, "2.0.2", true);

    public BrickletIsolatorWrapper(String uid, IPConnection ipcon) {
        super(uid, ipcon);
    }

    private List<ScheduledFuture<?>> manualChannelUpdates = new ArrayList<ScheduledFuture<?>>();
    private List<ListenerReg> listenerRegs = new ArrayList<ListenerReg>();

    public void cancelManualUpdates() {
        manualChannelUpdates.forEach(f -> f.cancel(true));
    }

    public <T> T reg(T listener, Consumer<T> toRemove) {
        listenerRegs.add(new ListenerReg<T>(listener, toRemove));
        return listener;
    }

    
    private final Logger logger = LoggerFactory.getLogger(BrickletIsolatorWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletIsolatorWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        this.setResponseExpectedAll(true);
        BrickletIsolatorConfig cfg = (BrickletIsolatorConfig) config.as(BrickletIsolatorConfig.class);
        this.addStatisticsListener(this.reg((messagesFromBrick, messagesFromBricklet, connectedBrickletDeviceIdentifier, connectedBrickletUID) -> {if(true) {updateStateFn.accept("BrickletIsolatorMessagesFromBrick", transformBrickletIsolatorMessagesFromBrickCallback0(messagesFromBrick, messagesFromBricklet, connectedBrickletDeviceIdentifier, connectedBrickletUID, cfg));}}, this::removeStatisticsListener));
		this.addStatisticsListener(this.reg((messagesFromBrick, messagesFromBricklet, connectedBrickletDeviceIdentifier, connectedBrickletUID) -> {if(true) {updateStateFn.accept("BrickletIsolatorMessagesFromBricklet", transformBrickletIsolatorMessagesFromBrickletCallback0(messagesFromBrick, messagesFromBricklet, connectedBrickletDeviceIdentifier, connectedBrickletUID, cfg));}}, this::removeStatisticsListener));
		this.addStatisticsListener(this.reg((messagesFromBrick, messagesFromBricklet, connectedBrickletDeviceIdentifier, connectedBrickletUID) -> {if(true) {updateStateFn.accept("BrickletIsolatorConnectedBrickletDeviceName", transformBrickletIsolatorConnectedBrickletDeviceNameCallback0(messagesFromBrick, messagesFromBricklet, connectedBrickletDeviceIdentifier, connectedBrickletUID, cfg));}}, this::removeStatisticsListener));
		this.addStatisticsListener(this.reg((messagesFromBrick, messagesFromBricklet, connectedBrickletDeviceIdentifier, connectedBrickletUID) -> {if(true) {updateStateFn.accept("BrickletIsolatorConnectedBrickletUID", transformBrickletIsolatorConnectedBrickletUIDCallback0(messagesFromBrick, messagesFromBricklet, connectedBrickletDeviceIdentifier, connectedBrickletUID, cfg));}}, this::removeStatisticsListener));
        this.setStatisticsCallbackConfiguration(cfg.statisticsUpdateInterval, true);
		this.setStatusLEDConfig(cfg.statusLEDConfig);
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        listenerRegs.forEach(reg -> reg.toRemove.accept(reg.listener));

        BrickletIsolatorConfig cfg = (BrickletIsolatorConfig) config.as(BrickletIsolatorConfig.class);
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletIsolatorConfig cfg = (BrickletIsolatorConfig) config.as(BrickletIsolatorConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletIsolatorMessagesFromBrick");
		result.add("BrickletIsolatorMessagesFromBricklet");
		result.add("BrickletIsolatorConnectedBrickletDeviceName");
		result.add("BrickletIsolatorConnectedBrickletUID");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletIsolatorMessagesFromBrick":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIsolatorMessagesFromBrick"), "Messages From Brick", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIsolatorMessagesFromBrick")).withDescription("Messages passed through the Isolator from the controlling Brick.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%d").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletIsolatorMessagesFromBricklet":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIsolatorMessagesFromBricklet"), "Messages From Bricklet", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIsolatorMessagesFromBricklet")).withDescription("Messages passed through the Isolator from the isolated Bricklet.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%d").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletIsolatorConnectedBrickletDeviceName":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIsolatorConnectedBrickletDeviceName"), "Connected Bricklet Device Name", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIsolatorConnectedBrickletDeviceName")).withDescription("Device Name of the isolated Bricklet.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            case "BrickletIsolatorConnectedBrickletUID":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIsolatorConnectedBrickletUID"), "Connected Bricklet UID", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIsolatorConnectedBrickletUID")).withDescription("UID of the isolated Bricklet.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Isolator Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Galvanically isolates any Bricklet from any Brick").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletIsolatorMessagesFromBrick", new ChannelTypeUID("tinkerforge", "BrickletIsolatorMessagesFromBrick")).withLabel("Messages From Brick").build(), new ChannelDefinitionBuilder("BrickletIsolatorMessagesFromBricklet", new ChannelTypeUID("tinkerforge", "BrickletIsolatorMessagesFromBricklet")).withLabel("Messages From Bricklet").build(), new ChannelDefinitionBuilder("BrickletIsolatorConnectedBrickletDeviceName", new ChannelTypeUID("tinkerforge", "BrickletIsolatorConnectedBrickletDeviceName")).withLabel("Connected Bricklet Device Name").build(), new ChannelDefinitionBuilder("BrickletIsolatorConnectedBrickletUID", new ChannelTypeUID("tinkerforge", "BrickletIsolatorConnectedBrickletUID")).withLabel("Connected Bricklet UID").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletisolator":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("statisticsUpdateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval for all statistics data in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Statistics Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletIsolatorMessagesFromBrick":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletIsolatorMessagesFromBricklet":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletIsolatorConnectedBrickletDeviceName":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletIsolatorConnectedBrickletUID":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIsolatorConfig cfg = (BrickletIsolatorConfig) config.as(BrickletIsolatorConfig.class);
        switch(channel) {
            case "BrickletIsolatorMessagesFromBrick": {
                   BrickletIsolatorMessagesFromBrickConfig channelCfg = channelConfig.as(BrickletIsolatorMessagesFromBrickConfig.class);
                   {
            BrickletIsolator.Statistics value = this.getStatistics();
            if(true)
                updateStateFn.accept(channel, transformBrickletIsolatorMessagesFromBrickGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletIsolatorMessagesFromBricklet": {
                   BrickletIsolatorMessagesFromBrickletConfig channelCfg = channelConfig.as(BrickletIsolatorMessagesFromBrickletConfig.class);
                   {
            BrickletIsolator.Statistics value = this.getStatistics();
            if(true)
                updateStateFn.accept(channel, transformBrickletIsolatorMessagesFromBrickletGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletIsolatorConnectedBrickletDeviceName": {
                   BrickletIsolatorConnectedBrickletDeviceNameConfig channelCfg = channelConfig.as(BrickletIsolatorConnectedBrickletDeviceNameConfig.class);
                   {
            BrickletIsolator.Statistics value = this.getStatistics();
            if(true)
                updateStateFn.accept(channel, transformBrickletIsolatorConnectedBrickletDeviceNameGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletIsolatorConnectedBrickletUID": {
                   BrickletIsolatorConnectedBrickletUIDConfig channelCfg = channelConfig.as(BrickletIsolatorConnectedBrickletUIDConfig.class);
                   {
            BrickletIsolator.Statistics value = this.getStatistics();
            if(true)
                updateStateFn.accept(channel, transformBrickletIsolatorConnectedBrickletUIDGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletIsolatorConfig cfg = (BrickletIsolatorConfig) config.as(BrickletIsolatorConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletIsolatorMessagesFromBrickCallback0(long messagesFromBrick, long messagesFromBricklet, int connectedBrickletDeviceIdentifier, String connectedBrickletUID, BrickletIsolatorConfig cfg) {
        return new QuantityType<>(messagesFromBrick, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIsolatorMessagesFromBrickletCallback0(long messagesFromBrick, long messagesFromBricklet, int connectedBrickletDeviceIdentifier, String connectedBrickletUID, BrickletIsolatorConfig cfg) {
        return new QuantityType<>(messagesFromBricklet, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIsolatorConnectedBrickletDeviceNameCallback0(long messagesFromBrick, long messagesFromBricklet, int connectedBrickletDeviceIdentifier, String connectedBrickletUID, BrickletIsolatorConfig cfg) {
        return new StringType(Helper.getDeviceName(connectedBrickletDeviceIdentifier));
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIsolatorConnectedBrickletUIDCallback0(long messagesFromBrick, long messagesFromBricklet, int connectedBrickletDeviceIdentifier, String connectedBrickletUID, BrickletIsolatorConfig cfg) {
        return new StringType(connectedBrickletUID);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIsolatorMessagesFromBrickGetter0(BrickletIsolator.Statistics value, BrickletIsolatorConfig cfg) {
        return new QuantityType<>(value.messagesFromBrick, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIsolatorMessagesFromBrickletGetter0(BrickletIsolator.Statistics value, BrickletIsolatorConfig cfg) {
        return new QuantityType<>(value.messagesFromBricklet, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIsolatorConnectedBrickletDeviceNameGetter0(BrickletIsolator.Statistics value, BrickletIsolatorConfig cfg) {
        return new StringType(Helper.getDeviceName(value.connectedBrickletDeviceIdentifier));
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIsolatorConnectedBrickletUIDGetter0(BrickletIsolator.Statistics value, BrickletIsolatorConfig cfg) {
        return new StringType(value.connectedBrickletUID);
    }

}