/* ***********************************************************
 * This file was automatically generated on 2020-02-28.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.function.Consumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingStatus;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.thing.CommonTriggerEvents;

import com.tinkerforge.BrickletJoystick;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletJoystickWrapper extends BrickletJoystick implements StandardFlashable, DeviceWrapper {
    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletJoystick.DEVICE_DISPLAY_NAME, "brickletjoystick", BrickletJoystick.DEVICE_IDENTIFIER, BrickletJoystickWrapper.class, BrickletJoystickActions.class, "2.0.0", false);

    public BrickletJoystickWrapper(String uid, IPConnection ipcon) {
        super(uid, ipcon);
    }

    private List<ScheduledFuture<?>> manualChannelUpdates = new ArrayList<ScheduledFuture<?>>();
    private List<ListenerReg> listenerRegs = new ArrayList<ListenerReg>();

    public void cancelManualUpdates() {
        manualChannelUpdates.forEach(f -> f.cancel(true));
    }

    public <T> T reg(T listener, Consumer<T> toRemove) {
        listenerRegs.add(new ListenerReg<T>(listener, toRemove));
        return listener;
    }

    
    private final Logger logger = LoggerFactory.getLogger(BrickletJoystickWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletJoystickWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        this.setResponseExpectedAll(true);
        BrickletJoystickConfig cfg = (BrickletJoystickConfig) config.as(BrickletJoystickConfig.class);
        this.addPositionListener(this.reg((x, y) -> {if(true) {updateStateFn.accept("BrickletJoystickPositionX", transformBrickletJoystickPositionXCallback0(x, y, cfg));}}, this::removePositionListener));
		this.addPositionListener(this.reg((x, y) -> {if(true) {updateStateFn.accept("BrickletJoystickPositionY", transformBrickletJoystickPositionYCallback0(x, y, cfg));}}, this::removePositionListener));
		this.addPressedListener(this.reg(() -> {if(true) {triggerChannelFn.accept("BrickletJoystickPressed", transformBrickletJoystickPressedCallback0(cfg));}}, this::removePressedListener));
		this.addReleasedListener(this.reg(() -> {if(true) {triggerChannelFn.accept("BrickletJoystickPressed", transformBrickletJoystickPressedCallback1(cfg));}}, this::removeReleasedListener));
        this.setPositionCallbackPeriod(cfg.positionUpdateInterval);
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        listenerRegs.forEach(reg -> reg.toRemove.accept(reg.listener));

        BrickletJoystickConfig cfg = (BrickletJoystickConfig) config.as(BrickletJoystickConfig.class);
        this.setPositionCallbackPeriod(0);
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletJoystickConfig cfg = (BrickletJoystickConfig) config.as(BrickletJoystickConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletJoystickPositionX");
		result.add("BrickletJoystickPositionY");
		result.add("BrickletJoystickPressed");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletJoystickPosition":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletJoystickPosition"), "Position", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletJoystickPosition")).withDescription("The position of the joystick. The value ranges between -100 and 100 for both axis. The middle position of the joystick is x=0, y=0. The returned values are averaged and calibrated.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(-100)).withMaximum(BigDecimal.valueOf(100)).withPattern("%d %unit%").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Joystick Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("2-axis joystick with push-button").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletJoystickPositionX", new ChannelTypeUID("tinkerforge", "BrickletJoystickPosition")).withLabel("Position X").build(), new ChannelDefinitionBuilder("BrickletJoystickPositionY", new ChannelTypeUID("tinkerforge", "BrickletJoystickPosition")).withLabel("Position Y").build(), new ChannelDefinitionBuilder("BrickletJoystickPressed", new ChannelTypeUID("system", "rawbutton")).withLabel("Pressed").withDescription("Triggers if the button is pressed or released").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletjoystick":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("positionUpdateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval for X and Y position in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Position Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletJoystickPosition":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletJoystickConfig cfg = (BrickletJoystickConfig) config.as(BrickletJoystickConfig.class);
        switch(channel) {
            case "BrickletJoystickPositionX": {
                   BrickletJoystickPositionConfig channelCfg = channelConfig.as(BrickletJoystickPositionConfig.class);
                   {
            BrickletJoystick.Position value = this.getPosition();
            if(true)
                updateStateFn.accept(channel, transformBrickletJoystickPositionXGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletJoystickPositionY": {
                   BrickletJoystickPositionConfig channelCfg = channelConfig.as(BrickletJoystickPositionConfig.class);
                   {
            BrickletJoystick.Position value = this.getPosition();
            if(true)
                updateStateFn.accept(channel, transformBrickletJoystickPositionYGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletJoystickPressed":
                   {
            boolean value = this.isPressed();
            if(true)
                triggerChannelFn.accept(channel, transformBrickletJoystickPressedGetter0(value, cfg));
        }
                   return;
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletJoystickConfig cfg = (BrickletJoystickConfig) config.as(BrickletJoystickConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletJoystickPositionXCallback0(short x, short y, BrickletJoystickConfig cfg) {
        return new QuantityType<>(x, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletJoystickPositionYCallback0(short x, short y, BrickletJoystickConfig cfg) {
        return new QuantityType<>(y, SmartHomeUnits.ONE);
    }
	    private String transformBrickletJoystickPressedCallback0(BrickletJoystickConfig cfg) {
        return CommonTriggerEvents.PRESSED;
    }
	    private String transformBrickletJoystickPressedCallback1(BrickletJoystickConfig cfg) {
        return CommonTriggerEvents.RELEASED;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletJoystickPositionXGetter0(BrickletJoystick.Position value, BrickletJoystickConfig cfg) {
        return new QuantityType<>(value.x, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletJoystickPositionYGetter0(BrickletJoystick.Position value, BrickletJoystickConfig cfg) {
        return new QuantityType<>(value.y, SmartHomeUnits.ONE);
    }
	    private String transformBrickletJoystickPressedGetter0(boolean value, BrickletJoystickConfig cfg) {
        return value ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }

}