/* ***********************************************************
 * This file was automatically generated on 2020-02-28.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.function.Consumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingStatus;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.StringType;

import com.tinkerforge.BrickletLoadCellV2;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletLoadCellV2Wrapper extends BrickletLoadCellV2 implements CoMCUFlashable, DeviceWrapper {
    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletLoadCellV2.DEVICE_DISPLAY_NAME, "brickletloadcellv2", BrickletLoadCellV2.DEVICE_IDENTIFIER, BrickletLoadCellV2Wrapper.class, BrickletLoadCellV2Actions.class, "2.0.0", true);

    public BrickletLoadCellV2Wrapper(String uid, IPConnection ipcon) {
        super(uid, ipcon);
    }

    private List<ScheduledFuture<?>> manualChannelUpdates = new ArrayList<ScheduledFuture<?>>();
    private List<ListenerReg> listenerRegs = new ArrayList<ListenerReg>();

    public void cancelManualUpdates() {
        manualChannelUpdates.forEach(f -> f.cancel(true));
    }

    public <T> T reg(T listener, Consumer<T> toRemove) {
        listenerRegs.add(new ListenerReg<T>(listener, toRemove));
        return listener;
    }

    
    private final Logger logger = LoggerFactory.getLogger(BrickletLoadCellV2Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletLoadCellV2Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        this.setResponseExpectedAll(true);
        BrickletLoadCellV2Config cfg = (BrickletLoadCellV2Config) config.as(BrickletLoadCellV2Config.class);
        this.addWeightListener(this.reg((weight) -> {if(true) {updateStateFn.accept("BrickletLoadCellV2Weight", transformBrickletLoadCellV2WeightCallback0(weight, cfg));}}, this::removeWeightListener));
        this.setConfiguration(cfg.measurementRate, cfg.gain);
		this.setMovingAverage(cfg.movingAverage);
		this.setInfoLEDConfig(cfg.infoLED);
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletLoadCellV2WeightConfig channelCfg = getChannelConfigFn.apply("BrickletLoadCellV2Weight").as(BrickletLoadCellV2WeightConfig.class);
		this.setWeightCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        listenerRegs.forEach(reg -> reg.toRemove.accept(reg.listener));

        BrickletLoadCellV2Config cfg = (BrickletLoadCellV2Config) config.as(BrickletLoadCellV2Config.class);
        this.setWeightCallbackConfiguration(0, true, 'x', 0, 0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletLoadCellV2Config cfg = (BrickletLoadCellV2Config) config.as(BrickletLoadCellV2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletLoadCellV2Weight");
		result.add("BrickletLoadCellV2Tare");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletLoadCellV2Weight":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletLoadCellV2Weight"), "Weight", "Number:Mass").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletLoadCellV2Weight")).withDescription("The currently measured weight")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withPattern("%d %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletLoadCellV2Tare":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletLoadCellV2Tare"), "Tare", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletLoadCellV2Tare")).withDescription("Sets the currently measured weight as tare weight.")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("TARE", "Tare")).build()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Load Cell Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures weight with a load cell").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletLoadCellV2Weight", new ChannelTypeUID("tinkerforge", "BrickletLoadCellV2Weight")).withLabel("Weight").build(), new ChannelDefinitionBuilder("BrickletLoadCellV2Tare", new ChannelTypeUID("tinkerforge", "BrickletLoadCellV2Tare")).withLabel("Tare").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletloadcellv2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("movingAverage", Type.INTEGER).withDefault("4").withDescription("The length of a moving averaging for the weight value.<br/><br/>Setting the length to 1 will turn the averaging off. With less averaging, there is more noise on the data.").withLabel("Moving Average").withAdvanced(true).withMinimum(BigDecimal.valueOf(1)).withMaximum(BigDecimal.valueOf(100)).build(), ConfigDescriptionParameterBuilder.create("measurementRate", Type.INTEGER).withDefault("0").withDescription("The rate can be either 10Hz or 80Hz. A faster rate will produce more noise.").withLabel("Measurement Rate").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "10Hz"), new ParameterOption("1", "80Hz"))).build(), ConfigDescriptionParameterBuilder.create("gain", Type.INTEGER).withDefault("0").withDescription("The gain can be 128x, 64x or 32x. It represents a measurement range of ±20mV, ±40mV and ±80mV respectively. The Load Cell Bricklet uses an excitation voltage of 5V and most load cells use an output of 2mV/V. That means the voltage range is ±15mV for most load cells (i.e. gain of 128x is best). If you don't know what all of this means you should keep it at 128x, it will most likely be correct.").withLabel("Gain").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "128x"), new ParameterOption("1", "64x"), new ParameterOption("2", "32x"))).build(), ConfigDescriptionParameterBuilder.create("infoLED", Type.INTEGER).withDefault("0").withDescription("Configures the info LED to be either turned off, turned on, or blink in heartbeat mode.").withLabel("Info LED").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"))).build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletLoadCellV2Weight":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletLoadCellV2Tare":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletLoadCellV2Config cfg = (BrickletLoadCellV2Config) config.as(BrickletLoadCellV2Config.class);
        switch(channel) {
            case "BrickletLoadCellV2Weight": {
                   BrickletLoadCellV2WeightConfig channelCfg = channelConfig.as(BrickletLoadCellV2WeightConfig.class);
                   {
            int value = this.getWeight();
            if(true)
                updateStateFn.accept(channel, transformBrickletLoadCellV2WeightGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletLoadCellV2Tare":
               return;
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = new ArrayList<SetterRefresh>();
        BrickletLoadCellV2Config cfg = (BrickletLoadCellV2Config) config.as(BrickletLoadCellV2Config.class);
        switch(channel) {
            case "BrickletLoadCellV2Tare":
                if (command instanceof StringType) {
                    BrickletLoadCellV2TareConfig channelCfg = channelConfig.as(BrickletLoadCellV2TareConfig.class);
                    StringType cmd = (StringType) command;
                    this.tare();
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletLoadCellV2Weight", 0));
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletLoadCellV2WeightCallback0(int weight, BrickletLoadCellV2Config cfg) {
        return new QuantityType<>(weight, SIUnits.GRAM);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletLoadCellV2WeightGetter0(int value, BrickletLoadCellV2Config cfg) {
        return new QuantityType<>(value, SIUnits.GRAM);
    }

}