package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.smarthome.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.util.Map;
import java.util.HashMap;

import com.tinkerforge.TinkerforgeException;
import com.tinkerforge.BrickletRGBLEDMatrix;

@ThingActionsScope(name = "tinkerforge")
@NonNullByDefault
public class BrickletRGBLEDMatrixActions implements ThingActions {

    private @Nullable DeviceHandler handler;

    @Override
    public void setThingHandler(@Nullable ThingHandler handler) { this.handler = (DeviceHandler) handler; }

    @Override
    public @Nullable ThingHandler getThingHandler() { return handler; }

        @RuleAction(label = "Get Red")
    public @ActionOutput(name = "red", type="int[]")
           Map<String, Object> brickletRGBLEDMatrixGetRed(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int[] value = ((BrickletRGBLEDMatrixWrapper)this.handler.getDevice()).getRed();
        
        result.put("red", value);
        return result;
    }

    public static Map<String, Object> brickletRGBLEDMatrixGetRed(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            return ((BrickletRGBLEDMatrixActions) actions).brickletRGBLEDMatrixGetRed();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Get Green")
    public @ActionOutput(name = "green", type="int[]")
           Map<String, Object> brickletRGBLEDMatrixGetGreen(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int[] value = ((BrickletRGBLEDMatrixWrapper)this.handler.getDevice()).getGreen();
        
        result.put("green", value);
        return result;
    }

    public static Map<String, Object> brickletRGBLEDMatrixGetGreen(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            return ((BrickletRGBLEDMatrixActions) actions).brickletRGBLEDMatrixGetGreen();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Get Blue")
    public @ActionOutput(name = "blue", type="int[]")
           Map<String, Object> brickletRGBLEDMatrixGetBlue(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int[] value = ((BrickletRGBLEDMatrixWrapper)this.handler.getDevice()).getBlue();
        
        result.put("blue", value);
        return result;
    }

    public static Map<String, Object> brickletRGBLEDMatrixGetBlue(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            return ((BrickletRGBLEDMatrixActions) actions).brickletRGBLEDMatrixGetBlue();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Set Red")
    public void brickletRGBLEDMatrixSetRed(
            @ActionInput(name = "red") int[] red) throws TinkerforgeException {
        ((BrickletRGBLEDMatrixWrapper)this.handler.getDevice()).setRed(red);
        
    }

    public static void brickletRGBLEDMatrixSetRed(@Nullable ThingActions actions, int[] red) throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            ((BrickletRGBLEDMatrixActions) actions).brickletRGBLEDMatrixSetRed(red);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Set Green")
    public void brickletRGBLEDMatrixSetGreen(
            @ActionInput(name = "green") int[] green) throws TinkerforgeException {
        ((BrickletRGBLEDMatrixWrapper)this.handler.getDevice()).setGreen(green);
        
    }

    public static void brickletRGBLEDMatrixSetGreen(@Nullable ThingActions actions, int[] green) throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            ((BrickletRGBLEDMatrixActions) actions).brickletRGBLEDMatrixSetGreen(green);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Set Blue")
    public void brickletRGBLEDMatrixSetBlue(
            @ActionInput(name = "blue") int[] blue) throws TinkerforgeException {
        ((BrickletRGBLEDMatrixWrapper)this.handler.getDevice()).setBlue(blue);
        
    }

    public static void brickletRGBLEDMatrixSetBlue(@Nullable ThingActions actions, int[] blue) throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            ((BrickletRGBLEDMatrixActions) actions).brickletRGBLEDMatrixSetBlue(blue);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Get Frame Duration")
    public @ActionOutput(name = "frameDuration", type="int")
           Map<String, Object> brickletRGBLEDMatrixGetFrameDuration(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletRGBLEDMatrixWrapper)this.handler.getDevice()).getFrameDuration();
        
        result.put("frameDuration", value);
        return result;
    }

    public static Map<String, Object> brickletRGBLEDMatrixGetFrameDuration(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            return ((BrickletRGBLEDMatrixActions) actions).brickletRGBLEDMatrixGetFrameDuration();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Draw Frame")
    public void brickletRGBLEDMatrixDrawFrame(
            ) throws TinkerforgeException {
        ((BrickletRGBLEDMatrixWrapper)this.handler.getDevice()).drawFrame();
        
    }

    public static void brickletRGBLEDMatrixDrawFrame(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            ((BrickletRGBLEDMatrixActions) actions).brickletRGBLEDMatrixDrawFrame();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Get Supply Voltage")
    public @ActionOutput(name = "voltage", type="int")
           Map<String, Object> brickletRGBLEDMatrixGetSupplyVoltage(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletRGBLEDMatrixWrapper)this.handler.getDevice()).getSupplyVoltage();
        
        result.put("voltage", value);
        return result;
    }

    public static Map<String, Object> brickletRGBLEDMatrixGetSupplyVoltage(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            return ((BrickletRGBLEDMatrixActions) actions).brickletRGBLEDMatrixGetSupplyVoltage();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Read UID")
    public @ActionOutput(name = "uid", type="long")
           Map<String, Object> brickletRGBLEDMatrixReadUID(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        long value = ((BrickletRGBLEDMatrixWrapper)this.handler.getDevice()).readUID();
        
        result.put("uid", value);
        return result;
    }

    public static Map<String, Object> brickletRGBLEDMatrixReadUID(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            return ((BrickletRGBLEDMatrixActions) actions).brickletRGBLEDMatrixReadUID();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Get Chip Temperature")
    public @ActionOutput(name = "temperature", type="int")
           Map<String, Object> brickletRGBLEDMatrixGetChipTemperature(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletRGBLEDMatrixWrapper)this.handler.getDevice()).getChipTemperature();
        
        result.put("temperature", value);
        return result;
    }

    public static Map<String, Object> brickletRGBLEDMatrixGetChipTemperature(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            return ((BrickletRGBLEDMatrixActions) actions).brickletRGBLEDMatrixGetChipTemperature();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Get Status LED Config")
    public @ActionOutput(name = "config", type="int")
           Map<String, Object> brickletRGBLEDMatrixGetStatusLEDConfig(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletRGBLEDMatrixWrapper)this.handler.getDevice()).getStatusLEDConfig();
        
        result.put("config", value);
        return result;
    }

    public static Map<String, Object> brickletRGBLEDMatrixGetStatusLEDConfig(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            return ((BrickletRGBLEDMatrixActions) actions).brickletRGBLEDMatrixGetStatusLEDConfig();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Get Bootloader Mode")
    public @ActionOutput(name = "mode", type="int")
           Map<String, Object> brickletRGBLEDMatrixGetBootloaderMode(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletRGBLEDMatrixWrapper)this.handler.getDevice()).getBootloaderMode();
        
        result.put("mode", value);
        return result;
    }

    public static Map<String, Object> brickletRGBLEDMatrixGetBootloaderMode(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            return ((BrickletRGBLEDMatrixActions) actions).brickletRGBLEDMatrixGetBootloaderMode();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Get SPITFP Error Count")
    public @ActionOutput(name = "errorCountAckChecksum", type="long")
           @ActionOutput(name = "errorCountMessageChecksum", type="long")
           @ActionOutput(name = "errorCountFrame", type="long")
           @ActionOutput(name = "errorCountOverflow", type="long")
           Map<String, Object> brickletRGBLEDMatrixGetSPITFPErrorCount(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        BrickletRGBLEDMatrix.SPITFPErrorCount value = ((BrickletRGBLEDMatrixWrapper)this.handler.getDevice()).getSPITFPErrorCount();
        
        result.put("errorCountAckChecksum", value.errorCountAckChecksum);
        result.put("errorCountMessageChecksum", value.errorCountMessageChecksum);
        result.put("errorCountFrame", value.errorCountFrame);
        result.put("errorCountOverflow", value.errorCountOverflow);
        return result;
    }

    public static Map<String, Object> brickletRGBLEDMatrixGetSPITFPErrorCount(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            return ((BrickletRGBLEDMatrixActions) actions).brickletRGBLEDMatrixGetSPITFPErrorCount();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Get Identity")
    public @ActionOutput(name = "uid", type="String")
           @ActionOutput(name = "connectedUid", type="String")
           @ActionOutput(name = "position", type="char")
           @ActionOutput(name = "hardwareVersion", type="int[]")
           @ActionOutput(name = "firmwareVersion", type="int[]")
           @ActionOutput(name = "deviceIdentifier", type="int")
           Map<String, Object> brickletRGBLEDMatrixGetIdentity(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        BrickletRGBLEDMatrix.Identity value = ((BrickletRGBLEDMatrixWrapper)this.handler.getDevice()).getIdentity();
        
        result.put("uid", value.uid);
        result.put("connectedUid", value.connectedUid);
        result.put("position", value.position);
        result.put("hardwareVersion", value.hardwareVersion);
        result.put("firmwareVersion", value.firmwareVersion);
        result.put("deviceIdentifier", value.deviceIdentifier);
        return result;
    }

    public static Map<String, Object> brickletRGBLEDMatrixGetIdentity(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            return ((BrickletRGBLEDMatrixActions) actions).brickletRGBLEDMatrixGetIdentity();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }
}
